.text
.set LSREG, 0x3F
.set LSPH,  0x3E
.set LSPL,  0x3D

.globl switchtask
	.type switchtask, @function
switchtask:
	/* store status register via r0 */
	in   r0, LSREG
	
	/* disable interrupts */
	cli

	/* save old SREG */
	push r0
	
	/* save registers */
	push r2
	push r3
	push r4
	push r5
	push r6
	push r7
	push r8
	push r9
	push r10
	push r11
	push r12
	push r13
	push r14
	push r15
	push r16
	push r17

	/* save stack pointer */
	movw r26, r22 /* move word r27:r26 <- r23:r22 */
	in r0, LSPL
	st x+, r0
	in r0, LSPH
	st x, r0
	
	/* switch stack and restore context */
	out LSPL, r24
	out LSPH, r25
	
	pop r17
	pop r16
	pop r15
	pop r14
	pop r13
	pop r12
	pop r11
	pop r10
	pop r9
	pop r8
	pop r7
	pop r6
	pop r5
	pop r4
	pop r3
	pop r2

	/* restore status register */
	pop r0
	out LSREG, r0

	/* transfer control */
	ret

.globl dispatch
	.type dispatch, @function
dispatch:
	/* switch stack and restore context */
	out LSPL, r24
	out LSPH, r25
	
	pop r17
	pop r16
	pop r15
	pop r14
	pop r13
	pop r12
	pop r11
	pop r10
	pop r9
	pop r8
	pop r7
	pop r6
	pop r5
	pop r4
	pop r3
	pop r2

	/* restore status register */
	pop r0
	out LSREG, r0

	ret

