/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
static TaskType head_element(MACHINEWORD bbqindex) {
	return readyqueue[bbqstate[bbqindex].head];
}

/* Removes the head element of a readyqueue */
static MACHINEWORD remove_element(MACHINEWORD bbqindex) {
	if(bbqstate[bbqindex].head == bbqstate[bbqindex].end) {
		bbqstate[bbqindex].head = bbqstate[bbqindex].start;
	} else {
		bbqstate[bbqindex].head++;
	}
	return --bbqstate[bbqindex].fill;
}

/* Adds an element to the tail of a readyqueue */
static void add_element_last(uint8_t new_tid) {
	MACHINEWORD bbqindex=BasePriority(new_tid);
	if(bbqstate[bbqindex].fill <= (bbqstate[bbqindex].end-bbqstate[bbqindex].start)) {
		readyqueue[bbqstate[bbqindex].tail] = new_tid;
		bbqstate[bbqindex].fill++;

		if(bbqstate[bbqindex].tail==bbqstate[bbqindex].end) {
			bbqstate[bbqindex].tail=bbqstate[bbqindex].start;
		} else {
			bbqstate[bbqindex].tail++;
		}
	}
}

//? have_resources
/* Adds an element to the head of a readyqueue.
 * Used only in combination with priority ceiling, i.e. only the
 * currently running task will be added to the head of a queue.
 */
static void add_element_first(uint8_t new_tid) {
	MACHINEWORD bbqindex=BasePriority(new_tid);
	if(bbqstate[bbqindex].fill <= (bbqstate[bbqindex].end-bbqstate[bbqindex].start)) {
		bbqstate[bbqindex].fill++;

		if(bbqstate[bbqindex].head==bbqstate[bbqindex].start) {
			bbqstate[bbqindex].head=bbqstate[bbqindex].end;
		} else {
			bbqstate[bbqindex].head--;
		}

		readyqueue[bbqstate[bbqindex].head] = new_tid;
	}
}
//?

