/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
static StatusType activatetask(TaskType tid) {
//? debug
	fprintf(stderr, "[DEBUG] Activating task TID = %d\n", tid);

//?

	/* Maximum number of activations reached? */
//? have_multi_act
	if(__JOSEK_task_actcounter[tid] == 0)
//! have_readyqueues
	if(readytlist & (1<<tid))
//!
	if(readyplist & (1<<BasePriority(tid)))
//?
		return E_OS_LIMIT;

/* FIXME ISR2: need to do cli before checking Act Limit?! */
	DisableAllInterrupts();

//? have_multi_act
	__JOSEK_task_actcounter[tid]--;
//! have_readyqueues
	readytlist |= (1<<tid);
//?

//? have_readyqueues
	add_element_last(tid);
//?
	readyplist |= (1<<BasePriority(tid));
	EnableAllInterrupts();
	return E_OK;
}

StatusType ActivateTask(TaskType tid) {
	StatusType ret;
//? have_extstatus
/* FIXME will not work reliably with combined task ids */
	if (tid >= NUMTASKS) return E_OS_ID;

//?
	ret=activatetask(tid);

//? have_preemption
//? mixed_scheduling
  if (JOSEK_sched_enabled && (__JOSEK_task_flags[current_task] & JOSEK_TFLAG_PREEMPT))
//!
	if (JOSEK_sched_enabled)
//?
		schedule(0);
//?
	return ret;
}

