/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
uint8_t TerminateTask() {
//? assertions
	/* task priority must be at the default level */
	assert(current_task < (sizeof(__JOSEK_launch_functions)/sizeof(LaunchFunctionType)), "TerminateTask current_task range");
	assert(current_priority == taskdesc[current_task].defaultprio, "TerminateTask CurrentPriority");
//?
//? have_ecc
	remove_element(queues + current_priority - 1);
	taskdesc[current_task].numbertasks--;
	resetTID(current_task);
//?
	schedule(1);

	return E_OK;
}

uint8_t ChainTask(TaskType tid) {
	StatusType ret=E_OK;
//? assertions
	assert(tid < (sizeof(__JOSEK_launch_functions)/sizeof(LaunchFunctionType)), "ChainTask TID range");
	assert(current_task < (sizeof(__JOSEK_launch_functions)/sizeof(LaunchFunctionType)), "ChainTask current_task range");
//?
//? have_ecc
	remove_element(queues + current_priority - 1);
	taskdesc[current_task].numbertasks--;
	resetTID(current_task);
//?

	if(current_task == tid) {
		schedule(2);
	} else {
		ret=activatetask(tid);
		if(ret == E_OK) {
			schedule(1);
		}
	}

	return ret;
}
