/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
void JOSEK_ISR_IO(int32_t __signalnumber) {
	int32_t i;
	if (__signalnumber != SIGIO) return;
	for (i = 0; i < NUMBER_IO_ISR; i++) {
		if (IO_ISR_Table[i].events & IO_ISR_Table[i].revents) ISRFunction(i)(0);
	}
	IO_ISR_Processed = 1;
}

void *IO_ISR_Helper_Thread(void *Argument) {
	while (1) {
		int32_t PollReturn;
		int32_t i;

		for (i = 0; i < NUMBER_IO_ISR; i++) IO_ISR_Table[i].revents = 0;
		if ((PollReturn = poll(IO_ISR_Table, NUMBER_IO_ISR, -1)) < 0) {
			fprintf(stderr, "poll error: %s\n", strerror(errno));
			continue;
		}

		if (PollReturn == 0) continue;

		IO_ISR_Processed = 0;
		kill(getpid(), SIGIO);
		while (!IO_ISR_Processed) usleep(100 * 1000);	/* Wait until all interrupts are handled */
	}

	pthread_exit(NULL);
	return NULL;
}

StatusType SetupIOISR(int32_t fd, int32_t isrlvl, uint8_t target) {
	IO_ISR_Table[isrlvl].fd = fd;
	IO_ISR_Table[isrlvl].events = 0;
	
	if (target & POLL_READ) IO_ISR_Table[isrlvl].events |= POLLIN;
	if (target & POLL_WRITE) IO_ISR_Table[isrlvl].events |= POLLOUT;
	if (target & POLL_ERROR) IO_ISR_Table[isrlvl].events |= POLLERR;
	if (target & POLL_HANGUP) IO_ISR_Table[isrlvl].events |= POLLHUP;
	
	return E_OK;
}

