/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
/* Conforms to OSEK/VDX Binding Specification v1.42 */
#ifndef STATUSTYPEDEFINED
#define STATUSTYPEDEFINED
typedef uint8_t StatusType;
#define E_OK			0
#endif

typedef uint8_t PriorityType;

typedef void (*LaunchFunctionType)(void);
typedef enum {
	RUNNING, WAITING, READY, SUSPENDED
} TaskStateType;
typedef TaskStateType* TaskStateRefType;
extern const LaunchFunctionType __JOSEK_launch_functions[];
extern volatile TaskType current_task;
#define GetTaskID(id)						((*(id)) = current_task, E_OK)
extern StatusType GetTaskState(TaskType,TaskStateRefType);

extern uint8_t JOSEK_sched_enabled;

#define TASK(name)				void JOSEK_TASK_##name()
//? have_task_flags
#define JOSEK_TFLAG_PREEMPT 1
extern const uint8_t __JOSEK_task_flags[];
//?

//? have_multi_act
extern uint8_t __JOSEK_task_actcounter[];
//?

//? have_readyqueues
struct bbqueue {
	uint8_t head;
	uint8_t tail;
	uint8_t fill;
	const uint8_t start;
	const uint8_t end;
};
//! have_multi_act
extern const uint8_t __JOSEK_task_maxact[];
//?

//? have_resources
typedef uint8_t ResourceType;
//?
//? have_ecc
typedef uint8_t EventMaskType;
//?
//? timer
typedef //?TickType?// TickType;
typedef TickType* TickRefType;
//?
//? have_alarms
typedef struct {
	TickType maxallowedvalue;
	TickType ticksperbase;
//? have_extstatus
	TickType mincycle;
//?
} AlarmBaseType;
typedef AlarmBaseType* AlarmBaseRefType;
#define ALARMCALLBACK(name)		void JOSEK_CALLBACK_##name()
//?

#define E_OS_ACCESS		1
#define E_OS_CALLLEVEL	2
#define E_OS_ID			3
#define E_OS_LIMIT		4
#define E_OS_NUFUNC		5
#define E_OS_RESOURCE	6
#define E_OS_STATE		7
#define E_OS_VALUE		8
#define E_OS_NOFUNC		9

//? have_ioisr
#define POLL_READ		1
#define POLL_WRITE		2
#define POLL_ERROR		4
#define POLL_HANGUP		8
//?

//? have_linux
#define ISR2(name)				static __inline__ void JOSEK_ISR_##name(int32_t __signalnumber)
//! have_tasks
#define ISR2(vector)  static __inline__ void JOSEK_ISR_##vector(void); \
	ISR(vector) { \
		JOSEK_sched_enabled=0; \
		JOSEK_ISR_##vector(); \
		JOSEK_sched_enabled=1; \
//? have_preemption
//? mixed_scheduling
  if (__JOSEK_task_flags[current_task] & JOSEK_TFLAG_PREEMPT) \
//?
		schedule(0); \
//?
	} \
	void JOSEK_ISR_##vector()
//!
#define ISR2(vector)  static __inline__ void JOSEK_ISR_##vector()
//?
