/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
#ifndef ___JOSEK__OS___H
#define ___JOSEK__OS___H
#include <signal.h>

#ifdef __x86_64
#define CTXSIZE 136
#else
#define CTXSIZE 40
#endif

typedef unsigned char STATUSTYPE;
typedef unsigned char TASKTYPE;
typedef unsigned char RESOURCETYPE;
typedef unsigned char EVENTMASKTYPE;

#define E_OK			0
#define E_OS_ACCESS		1
#define E_OS_CALLLEVEL	2
#define E_OS_ID			3
#define E_OS_LIMIT		4
#define E_OS_NUFUNC		5
#define E_OS_RESOURCE	6
#define E_OS_STATE		7
#define E_OS_VALUE		8

#define TASK(name) void JOSEK_TASK_##name()

/* TODO These need to be autogenerated */
#define task_job1 1
#define task_job2 2
#define task_job3 3
#define RES_MOO 1
#define RES_FOO 2
#define RES_BAR 3

void Schedule();
void TerminateTask();
STATUSTYPE ActivateTask(TASKTYPE id);
void ChainTask(TASKTYPE id);
void GetTaskID(TASKTYPE *id);
void GetTaskState(TASKTYPE id, unsigned char *state);
void EnableAllInterrupts();
void DisableAllInterrupts();
void ResumeAllInterrupts();
void SuspendAllInterrupst();
void ResumeOSInterrupts();
void SuspendOSInterrupts();
void GetResource(RESOURCETYPE res);
void ReleaseResource(RESOURCETYPE res);
STATUSTYPE SetEvent(TASKTYPE id, EVENTMASKTYPE mask);
STATUSTYPE ClearEvent(EVENTMASKTYPE mask);
STATUSTYPE GetEvent(TASKTYPE id, EVENTMASKTYPE *mask);
STATUSTYPE WaitEvent(EVENTMASKTYPE mask);

#endif
