/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.classfile;
import keso.classfile.constantpool.*;

public class LocalVariableData {
	public int startBytecodepos;
	public int length;
	public int name_index;
	public int descriptor_index;
	public int index;
	public final String name;

	public LocalVariableData(String name, int startBytecodepos, int length, int name_index, int descriptor_index, int index) {
		this.startBytecodepos = startBytecodepos;
		this.length = length;
		this.name_index = name_index;
		this.descriptor_index=descriptor_index ;
		this.index=index;
		this.name=name;
	}

	public LocalVariableData(ConstantPool cPool, int startBytecodepos, int length, int name_index, int descriptor_index, int index) {
		this(cPool.getUTF8StringAt(name_index),startBytecodepos, length,name_index,descriptor_index,index);
	}

	public LocalVariableData copy() {
		return new LocalVariableData(name,startBytecodepos, length,name_index,descriptor_index,index);
	}
}
