/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.classfile;

public class Modifier {
  public static boolean isPublic(int accessFlags) {return (accessFlags & ClassData.ACC_PUBLIC) != 0;}
  public static boolean isPrivate(int accessFlags) {return (accessFlags & ClassData.ACC_PRIVATE) != 0;}
  public static boolean isProtected(int accessFlags) {return (accessFlags & ClassData.ACC_PROTECTED) != 0;}
  public static boolean isStatic(int accessFlags) {return (accessFlags & ClassData.ACC_STATIC) != 0;}
  public static boolean isFinal(int accessFlags) {return (accessFlags & ClassData.ACC_FINAL) != 0;}
  public static boolean isSynchronized(int accessFlags) {return (accessFlags & ClassData.ACC_SYNCHRONIZED) != 0;}
  public static boolean isVolatile(int accessFlags) {return (accessFlags & ClassData.ACC_VOLATILE) != 0;}
  public static boolean isTransient(int accessFlags) {return (accessFlags & ClassData.ACC_TRANSIENT) != 0;}
  public static boolean isNative(int accessFlags) {return (accessFlags & ClassData.ACC_NATIVE) != 0;}
  public static boolean isInterface(int accessFlags) {return (accessFlags & ClassData.ACC_INTERFACE) != 0;}
  public static boolean isAbstract(int accessFlags) {return (accessFlags & ClassData.ACC_ABSTRACT) != 0;}
}
