/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/


package keso.classfile.datatypes;
final public class BCDouble extends BCFloatDatatype {
  private double value;

  public BCDouble(double value) {this.value = value;}
  public double value() {return value;}
  public double doubleValue() {return value;}
    //public String toString() {return String.valueOf(value); }
  public int type() {return DOUBLE;}
  public long getBits() {return Double.doubleToLongBits(value);}

  public static final BCDouble VALUE_0 = new BCDouble(0.0);
  public static final BCDouble VALUE_1 = new BCDouble(1.0);

  public BCNumericDatatype combined(int operator, BCNumericDatatype op2) {
    double val1 = value;
    double val2 = ((BCDouble)op2).value;
    double result=0;
    switch (operator) {
    case ADD:  result = val1 + val2;   break;
    case SUB:  result = val1 - val2;   break;
    case MUL:  result = val1 * val2;   break;
    case DIV:  result = val1 / val2;   break;
    }
    return new BCDouble(result);
  }

  public BCNumericDatatype negated() {return new BCDouble(-value);}

}
