/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/


package keso.classfile.datatypes;
final public class BCFloat extends BCFloatDatatype {
  private float value;

  public BCFloat(float value) {this.value = value;}
  public float value() {return value;}
  public double doubleValue() {return value;}
    //public String toString() {return String.valueOf(value); }
  public int type() {return FLOAT;}
  public int getBits() {return Float.floatToIntBits(value);}

  public static final BCFloat VALUE_0 = new BCFloat(0);
  public static final BCFloat VALUE_1 = new BCFloat(1);
  public static final BCFloat VALUE_2 = new BCFloat(2);

  public BCNumericDatatype combined(int operator, BCNumericDatatype op2) {
    float val1 = value;
    float val2 = ((BCFloat)op2).value;
    float result=0;
    switch (operator) {
    case ADD:  result = val1 + val2;   break;
    case SUB:  result = val1 - val2;   break;
    case MUL:  result = val1 * val2;   break;
    case DIV:  result = val1 / val2;   break;
    }
    return new BCFloat(result);
  }

  public BCNumericDatatype negated() {return new BCFloat(-value);}

}
