/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/


package keso.classfile.datatypes;

abstract public class BCIntegerDatatype extends BCNumericDatatype {

  abstract long longValue();

  abstract protected BCIntegerDatatype getObjectFor(long value);

  // perform an arithmetic operation with this class
  public BCNumericDatatype combined(int operator, BCNumericDatatype op2) {
    long val1 = this.longValue();
    long val2 = ((BCIntegerDatatype)op2).longValue();
    long result=0;
    switch (operator) {
    case ADD:  result = val1 + val2;   break;
    case SUB:  result = val1 - val2;   break;
    case MUL:  result = val1 * val2;   break;
    case DIV:  result = val1 / val2;   break;
    case REM:  result = val1 % val2;   break;
    case SHL:  result = val1 << val2;  break;
    case SHR:  result = val1 >> val2;  break;
    case USHR: result = val1 >>> val2; break;
    case AND:  result = val1 & val2;   break;
    case OR:   result = val1 | val2;   break;
    case XOR:  result = val1 ^ val2;   break;
    }
    return getObjectFor(result);
  }

  public BCNumericDatatype negated() {
    return getObjectFor(-this.longValue());
  }

}
