/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/


package keso.classfile.datatypes;
final public class BCLong extends BCIntegerDatatype {
  private long value;

  public BCLong(long value) {this.value = value;}
  public long value() {return value;}
  public long longValue() {return value;}
  public int type() {return LONG;}

  public String toString() {return String.valueOf(value); }

  public static final BCLong VALUE_0 = new BCLong(0);
  public static final BCLong VALUE_1 = new BCLong(1);

  protected BCIntegerDatatype getObjectFor(long value) {
    return new BCLong(value);
  }

}
