/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/


package keso.classfile.datatypes;
// the following classes are used to represent values of
// different datatypes (e.g. to store constants in package bytecode.code)

abstract public class BCNumericDatatype extends BCBasicDatatype {

  // for combined()
  public static final int ADD = 0;
  public static final int SUB = 1;
  public static final int MUL = 2;
  public static final int DIV = 3;
  public static final int REM = 4;
  public static final int NEG = 5;
  public static final int SHL = 6;
  public static final int SHR = 7;
  public static final int USHR = 8;
  public static final int AND = 9;
  public static final int OR = 10;
  public static final int XOR = 11;

  // functions for performing arithmetic operations
  abstract public BCNumericDatatype combined(int operator, BCNumericDatatype op2);
  abstract public BCNumericDatatype negated();
}
