/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/


package keso.classfile.datatypes;

final public class BCReference extends BCBasicDatatype {
  private int value;

  public BCReference(int value) {this.value = value;}
  public int value() {return value;}
  public String toString() {
    if (value==0)
      return "NULL";
    else
      return "Ref:"+String.valueOf(value);
  }
  public int type() {return REFERENCE;}

  public static final BCReference NULL = new BCReference(0);

}
