/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package keso.compiler.analysis.connectiongraph;

/**
 * Different escape states determined by this analysis: An escape state of {@code Local} marks objects that do not
 * escape the method they are allocated in, an escape state of {@code Method} marks nodes that escape the method they
 * are created in, but not the thread, which can be used to remove synchronization primitives, and finally, an escape
 * state of {@code Global} marks nodes that escape both the method and the thread they are allocated in.
 */
public enum EscapeState {
	Local, Method, Global
};
