/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.backend;

import keso.compiler.*;
import keso.compiler.imcode.*;

public class CodeInfo {

	public int getArrayLength(IMNode array) throws CompileException {
		return array.getArrayLength();
	}

	public boolean isChecked(IMNode object, Coder coder)
	throws CompileException {
		return object.isChecked(coder);
	}

	public boolean isConstant(IMNode object)
	throws CompileException {
		return false;
	}

	public boolean canOmitArrayBoundsCheck(IMNode array, IMNode index)
	throws CompileException {
		return false;
	}

	public boolean canOmitMemRangeCheck(IMNode memory, IMNode offset,
			int chunkSize) throws CompileException {
		return false;
	}

	/**
	 * Determines whether a given memory node is an SHM segment whose name is
	 * known at compile time. If this is the case, the name is returned,
	 * otherwise <code>null</code>.
	 * @param memory Memory node.
	 * @return Name of the SHM segment if it can be determined, otherwise
	 *         <code>null</code>.
	 */
	public String getSHMName(IMNode memory) throws CompileException {
		return null;
	}

	/**
	 * Determines whether a given memory node is a message whose port name is
	 * known at compile time. If this is the case, the name is returned,
	 * otherwise <code>null</code>.
	 * @param memory Memory node.
	 * @return Name of the message port if it can be determined, otherwise
	 *         <code>null</code>.
	 */
	public String getPortName(IMNode memory) throws CompileException {
		return null;
	}
}
