package keso.compiler.backend.gradmp.ldparser;

%%

%public

%line

WHITE_SPACE=[\n\ \t\b\012\r]
DIGIT=[0-9]
ALPHA=[a-zA-Z_]
ALNUM=({DIGIT}|{ALPHA})

FDIGIT=({DIGIT}|[-])
XDIGIT=({DIGIT}|[a-fA-FxXkKmMgG])
XALPHA=({ALPHA}|[\$@])
XALNUM=({XALPHA}|{XDIGIT}|[-])

ATTRIB= [a-zA-Z] //[liarwxpLIARWXP]

JUNK=[^\n\ \t\b\012\r"{};"]

%state COMMENT MEMORY MEMCOMMENT

%%



<YYINITIAL>{WHITE_SPACE}	{ /*ignore*/ }


<YYINITIAL>"/*"			{ yybegin(COMMENT); }
<COMMENT>"*/"			{ yybegin(YYINITIAL); }
<COMMENT>\n				{ }
<COMMENT>.				{ }

<YYINITIAL>";" {
	//return new Yytoken( ';', yytext(), (yyline+1) );
}

<YYINITIAL>["{}"] {}

<YYINITIAL>{JUNK}+ {
	// . ohne ";{}"
	//<YYINITIAL>"//".*\n	{}
	if( yytext().equals("MEMORY") ) {
		yybegin(MEMORY);
		return new Yytoken( Parser.TKMEMORY, yytext(), (yyline+1) );
	} else {
		/*ignore*/
		//System.out.println("ignored \"" + yytext() + "\"" ); //DBG
	}
}




<MEMORY>{WHITE_SPACE} { }

<MEMORY>"/*"		{ yybegin(MEMCOMMENT); }
<MEMCOMMENT>"*/"	{ yybegin(MEMORY); }
<MEMCOMMENT>\n		{ }
<MEMCOMMENT>.		{ }


<MEMORY>["{}:,"=]	{
	char c = yytext().charAt(0);
	if( c == '}' ) {
		yybegin(YYINITIAL);
	}
	return new Yytoken( c, yytext(), (yyline+1) );
}

<MEMORY>"("{ATTRIB}*"!"?{ATTRIB}*")" {
	return new Yytoken( Parser.TKATTRIB, yytext(), (yyline+1) );
}

<MEMORY>{FDIGIT}{XDIGIT}* {
	//{DIGIT}.*
	return new Yytoken( Parser.TKNUMBER, yytext(), (yyline+1) );
}

<MEMORY>\".*\" {
	return new Yytoken( Parser.TKIDENTIFIER, yytext(), (yyline+1) );
}
<MEMORY>{XALPHA}{XALNUM}* {
	//.*
	return new Yytoken( Parser.TKIDENTIFIER, yytext(), (yyline+1) );
}


