/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
/*
	M.Strotz 2011
*/

package keso.compiler.backend.gradmp.ldparser.ast;

import java.util.*;

public final class LinkerScript extends Node {
	private final ArrayList<Stmt> m_list;

	public LinkerScript( String file, int line ) {
		super(file,line);
		m_list = new ArrayList<Stmt>();
	}

	public LinkerScript( Stmt first, String file, int line ) {
		this(file,line);
		add(first);
	}

	public void add( Stmt s ) {
		m_list.add( s );
	}

	public ArrayList<Stmt> list() {
		return m_list;
	}


	public void addMemoryBlocksTo( Collection<keso.compiler.backend.gradmp.MemoryBlock> mbs ) {
		for( Stmt s : list() ) {
			if( !(s instanceof MemoryStmt) ) continue;
			MemoryStmt ms = (MemoryStmt) s;
			mbs.addAll( ms.blocks() );
		}
	}
};
