/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
/*
	M.Strotz 2011
*/

package keso.compiler.backend.gradmp.ldparser.ast;

public final class MemoryBlock extends Node {
	private final keso.compiler.backend.gradmp.MemoryBlock m_mb;

	public MemoryBlock( Identifier name, MemoryAttributes attr, MemoryInterval mi, String file, int line ) {
		super(file,line);
		m_mb = new keso.compiler.backend.gradmp.MemoryBlock(
			name.string(),
			attr.string(),
			mi.origin(),
			mi.length()
		);
	}

	public MemoryBlock( Identifier name, MemoryInterval mi, String file, int line ) {
		super(file,line);
		m_mb = new keso.compiler.backend.gradmp.MemoryBlock(
			name.string(),
			mi.origin(),
			mi.length()
		);
	}

	public keso.compiler.backend.gradmp.MemoryBlock desc() {
		return m_mb;
	}
};
