/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
/*
	M.Strotz 2011
*/

package keso.compiler.backend.gradmp.ldparser.ast;

public final class MemoryInterval extends Node {
	private long m_org, m_len;

	public MemoryInterval( AssgnExpr a, AssgnExpr b, String file, int line ) throws RuntimeException {
		super(file,line);
		read(a); // if != 0...
		read(b);
	}

	public long origin() { return m_org; }
	public long length() { return m_len; }

	private int read( AssgnExpr a ) throws RuntimeException {
		return read( a.right().string(), ((Number)(a.left())).value() );
	}

	private int read( String id, long val ) { //throws IllegalArgumentException {
		if(	id.equals("ORIGIN")
			|| id.equals("org")
			|| id.equals("o")
		) {
			m_org = val;
			return 0;
		}

		if( id.equals("LENGTH")
			|| id.equals("len")
			|| id.equals("l")
		) {
			m_len = val;
			return 1;
		}

		//throw new IllegalArgumentException();
		return -1;
	}
};
