/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.config;

import java.util.ArrayList;
import java.util.List;

public class ArrayAttr<ParentType extends Set<?>> extends Attribute<ParentType> {

	private List<String> values = new ArrayList<String>();

	public ArrayAttr(ParentType parent, String ident, int line) {
		super(parent, ident, line);

	}

	public void add(String v) {
		values.add(v);
	}

	public int valueInt() { return values.size(); }

	public double valueDouble() { return (double)valueInt(); }

	public String valueString() { return values.toString(); }

	public boolean valueBoolean() { return values.size()>0; }

	public List<String> valueArray() {
		return values;
	}

	public int[] values() {
		int arr[] = new int[values.size()];
		for (int i = 0; i < values.size(); ++i) {
			arr[i]=Integer.parseInt(values.get(i));
		}
		return arr;
	}
}
