/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.config;

public class IntegerAttr<ParentType extends Set<?>> extends Attribute<ParentType> {
	private int value;

	public IntegerAttr(ParentType parent, String ident, String value, int line) {
		super(parent, ident, line);
		this.value = parseInt(value);
	}

	public int valueInt() {
		return value;
	}

	public double valueDouble() {
		return (double)value;
	}

	public String valueString() {
		return (new Integer(value)).toString();
	}

	public boolean valueBoolean() {
		return value!=0;
	}

	public static int parseInt( final String value ) {
		String s = value.toLowerCase();
		if( s.indexOf("0x") >= 0 ) {
			int sign = 1;
			if( s.charAt(0) == '-' ) {
				s = s.substring(3);
				sign = -1;
			} else if( s.charAt(1) == '+' ) {
				s = s.substring(3);
			} else {
				s = s.substring(2);
			}
			return sign * (int)Long.parseLong(s,0x10);
		} else {
			return Integer.parseInt(value);
		}
	}
}
