/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.config;

import keso.compiler.*;
import keso.compiler.config.domain.*;
import keso.compiler.backend.CoderOSEK;

public final class NativeResource extends ResourceDefinition {
	public NativeResource(NativeDomain dom, String name) {
		super(dom, name, -1);
	}

	public void toOIL(StringBuffer oil, String prefix, CoderOSEK coder) throws CompileException {
		oil.append(prefix);
		oil.append("RESOURCE ");
		oil.append(getIdentifier());
		oil.append(" {\n");

		oil.append(prefix);
		oil.append("\tRESOURCEPROPERTY = STANDARD;\n");
		oil.append(prefix);
		oil.append("};\n");
	}

	public String getIdentifier() { return ident; }
}
