/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.config.domain;

import keso.compiler.config.*;
import keso.compiler.config.parser.ParseException;

/**
 * This class represents the Definition of the special domain DomainZero.
 * This domain is part of the trusted codebase and contains tasks of the
 * runtime environment such as the garbage collector.
 */
public final class DomainZero extends NativeDomain {
	public DomainZero(SystemDefinition system) throws ParseException {
		super(system, "DomainZero", 0);
		addAttribute("CiAOTrusted", new StringAttr(this, "CiAOTrusted", "true", -1));
	}

	public String getComponent() {
		return "KESODomZero";
	}

	public String getIdentifier() { return "DomainZero"; }
}
