/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.imcode;

import keso.compiler.*;

public abstract class IMDataFlowObj extends IMDataFlow {

	protected final IMClass type;

	public IMDataFlowObj(BuilderOptions opts, IMClass type) {
		super(opts);
		if (type == null)
			this.type = this.type.findClass("java/lang/Object");
		else
			this.type = type;
	}

	@Override
	public final IMClass getType() {
		return type;
	}

	protected final IMClass foldTypes(IMClass imClass) {

		if (imClass == null) // Should not happen under normal circumstances
			return null;
		if (imClass.typeOf(type) == true)
			return type;

		// Find a common superclass
		while (type.typeOf(imClass) == false) {
			imClass = imClass.getSuperClass();
			if (imClass == null)
				return type.findClass("java/lang/Object");
		}
		return imClass;
	}

}
