/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.imcode;

import keso.compiler.*;

public abstract class IMDataFlowResource extends IMDataFlow {

	protected final IMDataFlow resource;
	protected final IMDataFlow name;

	public IMDataFlowResource(IMDataFlow resource, IMDataFlow name) {
		super(resource.opts);
		this.resource = resource;
		this.name     = name;
	}

	@Override
	public boolean isValid() {
		return resource.isValid();
	}

	@Override
	public boolean isConstant() {
		return resource.isConstant();
	}

	@Override
	public abstract String toReadableString();

	@Override
	public abstract IMDataFlow copy(IMClass type) throws CompileException;

	@Override
	public abstract IMDataFlow fold(IMDataFlow flow) throws CompileException;

	@Override
	public abstract IMDataFlow intersect(IMDataFlow flow)
	throws CompileException;

	@Override
	public IMConstant getValue() throws CompileException {
		return resource.getValue();
	}

	@Override
	public IMClass getType() {
		return resource.getType();
	}

	public IMDataFlow getName() {
		return name;
	}

}
