/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.imcode;

import keso.compiler.*;

public final class IMDefUseUpdater extends IMBasicVisitor {

	private final IMBasicBlock bb;

	public IMDefUseUpdater(IMBasicBlock bb) {
		this.bb = bb;
	}

	@Override
	public void visit(IMNode node) throws CompileException {
		IMSlot slot = node.getIMSlot();
		if (slot == null || slot.getDefiningStatement() == null)
			return;
		if (node.usesSlot())
			slot.use(bb, node);
		else if (node instanceof IMStoreLocalVariable
				|| slot.getDefiningStatement() == node)
			slot.redefine(bb, node);
	}

}
