/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.imcode;

import keso.compiler.*;
import keso.compiler.backend.Coder;
import keso.compiler.config.*;
import keso.compiler.config.domain.*;
import java.util.*;

/**
 * This class implements the class constructor of a remote service.
 */
final public class IMPortalServiceInit implements IMPortalInit {

    private ServiceDefinition serviceDefinition;
    private IMPortalService service;

    public IMPortalServiceInit(IMPortalService srv, ServiceDefinition srvDef) throws CompileException {
        service = srv;
        serviceDefinition = srvDef;
    }

		final public void translate(Coder coder) throws CompileException {
			// create service object
			ClassStore repository = coder.getClassStore();
			IMClass serviceClass = serviceDefinition.getServiceClass(repository);
			// Get all domains, a service is defined in
			//List<JavaDomain> services_domains = serviceDefinition.getDomains();
			List<JavaDomain> services_domains = service.getServicesDomains();
			for(JavaDomain jd : services_domains) {
				coder.global_add_allocConstObject(serviceClass, service.getServiceObjectNames(coder, jd));
				coder.global_add_init_end();
				coder.global_addln("\n");
			}
		}
}
