/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.imcode;

import keso.compiler.*;

final public class IMSlotPref extends IMSlot {

	public IMSlotPref(IMMethodFrame frame) {
		super(frame,"pref");
	}

	@Override
	public void setAlias(IMNode node) {
		throw new RuntimeException("pref can't have alias");
	}

	@Override
	public void setChecked(IMBasicBlock checked) throws CompileException {
		throw new CompileException("pref can't mark as checked");
	}

	@Override
	public boolean isChecked(IMBasicBlock current) {
		return false;
	}

	/*
	 * simple constant propagation.
	 */
	@Override
	public void propagateConstant(IMBasicBlock current, IMConstant const_node) {
		throw new RuntimeException("pref");
	}

	@Override
	public IMConstant varToConstant(IMBasicBlock current) {
		throw new RuntimeException("pref");
	}

	@Override
	public void setIsStackVar(int alias) {
		throw new RuntimeException("pref");
	}

	@Override
	public boolean isStackVariable(int stack_pos) {
		throw new RuntimeException("pref");
	}

	@Override
	public String definition() {
		return "object_t** pref";
	}

	@Override
	public String toString() { return "pref"; }
}
