/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.imcode;

import keso.compiler.*;
import keso.compiler.backend.Coder;

public abstract class IMSystemMethod extends IMMethod {

	public IMSystemMethod(IMClass clazz) throws CompileException {
		super(clazz);
	}

	@Override
	public boolean isPure() throws CompileException {
		return false;
	}

	@Override
	public boolean isConstant() throws CompileException {
		return false;
	}

	@Override
	final public boolean isInlineCandidate() throws CompileException {
		return false;
	}

	@Override
	final public int getNumberOfBasicBlocks() {
		return 0;
	}

	@Override
	final public boolean insertCode(IMMethod host_method,
			IMNode current, IMNode call, IMNode self, IMNode[] args,
			IMBasicBlock prev_bb, IMBasicBlock next_bb) throws CompileException {
		throw new CompileException("try to inline system method!");
	}

	@Override
	public void translate(Coder coder) throws CompileException {
		opts.warn("blind translate() method in "+this.getClass().getName());
	}

	@Override
	public boolean isEligibleForOptimization() throws CompileException {
		return false;
	}

}
