/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package keso.compiler.imcode;

import keso.compiler.CompileException;

/**
 * Skeleton class implementing IMTypedVisitor without any behavior.
 */
public abstract class IMTypedVisitorSimpleAdapter implements IMTypedVisitor {
	@Override
	public void visit(IMAllocation n) throws CompileException {}

	@Override
	public void visit(IMNullCheck n) throws CompileException {}

	@Override
	public void visit(IMLRem n) throws CompileException {}

	@Override
	public void visit(IMStoreLocalVariable n) throws CompileException {}

	@Override
	public void visit(IMCastL2D n) throws CompileException {}

	@Override
	public void visit(IMBStoreArray n) throws CompileException {}

	@Override
	public void visit(IMStackOperationSWAP n) throws CompileException {}

	@Override
	public void visit(IMNew n) throws CompileException {}

	@Override
	public void visit(IMShiftLeft n) throws CompileException {}

	@Override
	public void visit(IMAStoreLocalVariable n) throws CompileException {}

	@Override
	public void visit(IMCastD2F n) throws CompileException {}

	@Override
	public void visit(IMFAdd n) throws CompileException {}

	@Override
	public void visit(IMGoto n) throws CompileException {}

	@Override
	public void visit(IMNEConditionalBranch n) throws CompileException {}

	@Override
	public void visit(IMStackOperationDUP2_X1 n) throws CompileException {}

	@Override
	public void visit(IMBitXor n) throws CompileException {}

	@Override
	public void visit(IMCaughtException n) throws CompileException {}

	@Override
	public void visit(IMCastF2I n) throws CompileException {}

	@Override
	public void visit(IMLShiftRight2 n) throws CompileException {}

	@Override
	public void visit(IMDReadLocalVariable n) throws CompileException {}

	@Override
	public void visit(IMRem n) throws CompileException {}

	@Override
	public void visit(IMMul n) throws CompileException {}

	@Override
	public void visit(IMEpilog n) throws CompileException {}

	@Override
	public void visit(IMCastI2S n) throws CompileException {}

	@Override
	public void visit(IMIStoreLocalVariable n) throws CompileException {}

	@Override
	public void visit(IMDStoreLocalVariable n) throws CompileException {}

	@Override
	public void visit(IMIReadLocalVariable n) throws CompileException {}

	@Override
	public void visit(IMBitAnd n) throws CompileException {}

	@Override
	public void visit(IMStackOperationDUP_X2 n) throws CompileException {}

	@Override
	public void visit(IMStackOperationDUP2_X2 n) throws CompileException {}

	@Override
	public void visit(IMDRem n) throws CompileException {}

	@Override
	public void visit(IMLBitOr n) throws CompileException {}

	@Override
	public void visit(IMCastL2F n) throws CompileException {}

	@Override
	public void visit(IMIShiftRight2 n) throws CompileException {}

	@Override
	public void visit(IMLStoreLocalVariable n) throws CompileException {}

	@Override
	public void visit(IMLNeg n) throws CompileException {}

	@Override
	public void visit(IMCReadArray n) throws CompileException {}

	@Override
	public void visit(IMCastI2C n) throws CompileException {}

	@Override
	public void visit(IMIDiv n) throws CompileException {}

	@Override
	public void visit(IMCStoreArray n) throws CompileException {}

	@Override
	public void visit(IMFReadLocalVariable n) throws CompileException {}

	@Override
	public void visit(IMLEConditionalBranch n) throws CompileException {}

	@Override
	public void visit(IMNewArray n) throws CompileException {}

	@Override
	public void visit(IMEQConditionalBranch n) throws CompileException {}

	@Override
	public void visit(IMIStoreArray n) throws CompileException {}

	@Override
	public void visit(IMIConstant n) throws CompileException {}

	@Override
	public void visit(IMFNeg n) throws CompileException {}

	@Override
	public void visit(IMSub n) throws CompileException {}

	@Override
	public void visit(IMInstanceOf n) throws CompileException {}

	@Override
	public void visit(IMAReadLocalVariable n) throws CompileException {}

	@Override
	public void visit(IMInvokeStatic n) throws CompileException {}

	@Override
	public void visit(IMCastI2L n) throws CompileException {}

	@Override
	public void visit(IMGTConditionalBranch n) throws CompileException {}

	@Override
	public void visit(IMFStoreLocalVariable n) throws CompileException {}

	@Override
	public void visit(IMCastI2D n) throws CompileException {}

	@Override
	public void visit(IMLStoreArray n) throws CompileException {}

	@Override
	public void visit(IMCastD2I n) throws CompileException {}

	@Override
	public void visit(IMSStoreArray n) throws CompileException {}

	@Override
	public void visit(IMIBitXor n) throws CompileException {}

	@Override
	public void visit(IMLBitXor n) throws CompileException {}

	@Override
	public void visit(IMLShiftRight n) throws CompileException {}

	@Override
	public void visit(IMNeg n) throws CompileException {}

	@Override
	public void visit(IMLShiftLeft n) throws CompileException {}

	@Override
	public void visit(IMShiftRight n) throws CompileException {}

	@Override
	public void visit(IMINeg n) throws CompileException {}

	@Override
	public void visit(IMStackOperationDUP2 n) throws CompileException {}

	@Override
	public void visit(IMCheckCast n) throws CompileException {}

	@Override
	public void visit(IMConstant n) throws CompileException {}

	@Override
	public void visit(IMShiftRight2 n) throws CompileException {}

	@Override
	public void visit(IMDGCompare n) throws CompileException {}

	@Override
	public void visit(IMIBitOr n) throws CompileException {}

	@Override
	public void visit(IMDStoreArray n) throws CompileException {}

	@Override
	public void visit(IMDMul n) throws CompileException {}

	@Override
	public void visit(IMDNeg n) throws CompileException {}

	@Override
	public void visit(IMIRem n) throws CompileException {}

	@Override
	public void visit(IMPutStatic n) throws CompileException {}

	@Override
	public void visit(IMCastI2F n) throws CompileException {}

	@Override
	public void visit(IMCastD2L n) throws CompileException {}

	@Override
	public void visit(IMIMul n) throws CompileException {}

	@Override
	public void visit(IMCall n) throws CompileException {}

	@Override
	public void visit(IMCastF2D n) throws CompileException {}

	@Override
	public void visit(IMAObjConstant n) throws CompileException {}

	@Override
	public void visit(IMLConstant n) throws CompileException {}

	@Override
	public void visit(IMFConstant n) throws CompileException {}

	@Override
	public void visit(IMAReadArray n) throws CompileException {}

	@Override
	public void visit(IMReadLocalVariable n) throws CompileException {}

	@Override
	public void visit(IMDConstant n) throws CompileException {}

	@Override
	public void visit(IMFSub n) throws CompileException {}

	@Override
	public void visit(IMNewMultiArray n) throws CompileException {}

	@Override
	public void visit(IMThrow n) throws CompileException {}

	@Override
	public void visit(IMInvokeSpecial n) throws CompileException {}

	@Override
	public void visit(IMCastL2I n) throws CompileException {}

	@Override
	public void visit(IMGetField n) throws CompileException {}

	@Override
	public void visit(IMInvokeInterface n) throws CompileException {}

	@Override
	public void visit(IMAStoreArray n) throws CompileException {}

	@Override
	public void visit(IMStackOperationDUP n) throws CompileException {}

	@Override
	public void visit(IMReadArray n) throws CompileException {}

	@Override
	public void visit(IMLookupSwitch n) throws CompileException {}

	@Override
	public void visit(IMNewObjArray n) throws CompileException {}

	@Override
	public void visit(IMDSub n) throws CompileException {}

	@Override
	public void visit(IMIReadArray n) throws CompileException {}

	@Override
	public void visit(IMReturnSubroutine n) throws CompileException {}

	@Override
	public void visit(IMFStoreArray n) throws CompileException {}

	@Override
	public void visit(IMBReadArray n) throws CompileException {}

	@Override
	public void visit(IMDReadArray n) throws CompileException {}

	@Override
	public void visit(IMPutField n) throws CompileException {}

	@Override
	public void visit(IMAConstant n) throws CompileException {}

	@Override
	public void visit(IMNullConstant n) throws CompileException {}

	@Override
	public void visit(IMCompare n) throws CompileException {}

	@Override
	public void visit(IMBitOr n) throws CompileException {}

	@Override
	public void visit(IMSReadArray n) throws CompileException {}

	@Override
	public void visit(IMInvoke n) throws CompileException {}

	@Override
	public void visit(IMStackOperationDUP_X1 n) throws CompileException {}

	@Override
	public void visit(IMStoreArray n) throws CompileException {}

	@Override
	public void visit(IMPhi n) throws CompileException {}

	@Override
	public void visit(IMInvokeVirtual n) throws CompileException {}

	@Override
	public void visit(IMLReadLocalVariable n) throws CompileException {}

	@Override
	public void visit(IMStackOperationPOP n) throws CompileException {}

	@Override
	public void visit(IMDiv n) throws CompileException {}

	@Override
	public void visit(IMFDiv n) throws CompileException {}

	@Override
	public void visit(IMLMul n) throws CompileException {}

	@Override
	public void visit(IMFReadArray n) throws CompileException {}

	@Override
	public void visit(IMDDiv n) throws CompileException {}

	@Override
	public void visit(IMGetStatic n) throws CompileException {}

	@Override
	public void visit(IMTableSwitch n) throws CompileException {}

	@Override
	public void visit(IMAMTConstantStatic n) throws CompileException {}

	@Override
	public void visit(IMISub n) throws CompileException {}

	@Override
	public void visit(IMGEConditionalBranch n) throws CompileException {}

	@Override
	public void visit(IMLTConditionalBranch n) throws CompileException {}

	@Override
	public void visit(IMIBitAnd n) throws CompileException {}

	@Override
	public void visit(IMLDiv n) throws CompileException {}

	@Override
	public void visit(IMFLCompare n) throws CompileException {}

	@Override
	public void visit(IMAdd n) throws CompileException {}

	@Override
	public void visit(IMDLCompare n) throws CompileException {}

	@Override
	public void visit(IMFRem n) throws CompileException {}

	@Override
	public void visit(IMArrayLength n) throws CompileException {}

	@Override
	public void visit(IMDAdd n) throws CompileException {}

	@Override
	public void visit(IMIAdd n) throws CompileException {}

	@Override
	public void visit(IMLBitAnd n) throws CompileException {}

	@Override
	public void visit(IMLReadArray n) throws CompileException {}

	@Override
	public void visit(IMCastI2B n) throws CompileException {}

	@Override
	public void visit(IMCastF2L n) throws CompileException {}

	@Override
	public void visit(IMCast n) throws CompileException {}

	@Override
	public void visit(IMFMul n) throws CompileException {}

	@Override
	public void visit(IMIShiftLeft n) throws CompileException {}

	@Override
	public void visit(IMFGCompare n) throws CompileException {}

	@Override
	public void visit(IMMonitor n) throws CompileException {}

	@Override
	public void visit(IMAMemConstant n) throws CompileException {}

	@Override
	public void visit(IMLSub n) throws CompileException {}

	@Override
	public void visit(IMPopReturnAddr n) throws CompileException {}

	@Override
	public void visit(IMStackOperationPOP2 n) throws CompileException {}

	@Override
	public void visit(IMIShiftRight n) throws CompileException {}

	@Override
	public void visit(IMLAdd n) throws CompileException {}

	@Override
	public void visit(IMLCompare n) throws CompileException {}

	@Override
	public void visit(IMAMTConstant n) throws CompileException {}
}
