/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.imcode;

import keso.compiler.*;

public class IMUnaryNode extends IMNode {

	protected IMNode rOpr;

	protected IMUnaryNode() {
	}

	public IMUnaryNode(IMMethod method, int bc, int type, int bcpos) {
		super(method,bc,type,bcpos);
	}

	public boolean hasConstant() { return rOpr.isConstant(); }

	public boolean hasSideEffect() { return rOpr.hasSideEffect(); }

	/*
	public void visitNodes(IMVisitor visitor) throws CompileException {
		visitor.visit(this);
		rOpr.visit(visitor);
	}
	*/

	final public IMNode getRightNode() { return rOpr; }

	final public void setRightNode(IMNode opr) { rOpr = opr; }

	public IMNode processStack(VirtualOperandStack stack, IMNode extra_ops) throws CompileException {
		rOpr = stack.pop();
		stack.push(this);
		return null;
	}
}
