/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.imcode;

import keso.compiler.*;

final public class IMUpdateUsesVisitor extends IMBasicVisitor {

	private IMMethod method;
	private int old_uses;
	private int new_uses;

	public IMUpdateUsesVisitor(IMMethod method) {
		this.method=method;
	}

	public void begin() throws CompileException {
		old_uses = method.getMethodFrame().resetUses();
		new_uses = 0;
	}

	public void end() throws CompileException {
		if (old_uses!=new_uses) method.doAnotherSSARun();
	}

	@Override
	public void visit(IMNode node) throws CompileException {
		IMBasicBlock basicBlock = method.getCurrentBasicBlock();
		if (node.usesSlot()) {
			node.getIMSlot().use(basicBlock, node);
			++new_uses;
		}
	}

}
