/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.kni;

import keso.compiler.*;
import keso.compiler.imcode.*;
import keso.compiler.backend.*;

public class OSService extends Weavelet {

	public OSService(BuilderOptions opts, ClassStore repository) {
		super(opts, repository);
		joinPoints = new String[] { "keso/core/OSService\\..+" };
	}

	public void require(int domainID, String className, String methodName) {
	}

	public boolean affectInvokeStatic(IMInvoke node, IMMethod caller, IMMethod callee,
			IMNode args[], Coder coder) throws CompileException
	{
		if (callee.termed("getActiveApplicationMode()I")) {
			coder.add("GetActiveApplicationMode()");
		} else if (callee.termed("startOS(I)V")) {
			coder.add("StartOS(");
			args[0].translate(coder);
			coder.add(")");
		} else if (callee.termed("shutdownOS(I)V")) {
			coder.add("ShutdownOS((StatusType) ");
		 	args[0].translate(coder);
			coder.add(")");
			//coder.add("ShutdownOS(" + callee.getMethodArgument(0).toString() + ")");
		} else return false;

		return true;
	}

	public boolean ignoreMethodBody(IMClass clazz, IMMethod method) throws CompileException {
		return true;
	}
}
