/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package keso.compiler.kni;

import keso.compiler.*;
import keso.compiler.imcode.*;
import keso.compiler.backend.*;

public class Runtime extends Weavelet {

	public Runtime(BuilderOptions opts, ClassStore repository) {
		super(opts, repository);
		joinPoints = new String[] {
			"java/lang/Runtime\\.totalMemory\\(\\)J",
			"java/lang/Runtime\\.freeMemory\\(\\)J"
		};
	}

	public boolean affectInvokeVirtual(IMInvoke node, IMMethod caller,
			IMMethod callee, IMNode obj, IMNode args[], Coder coder)
		throws CompileException {
		if (callee.getMethodNameAndType().equals("totalMemory()J")) {
			coder.add("KESO_CURRENT_DOMAIN->heap_size");
		} else if (callee.getMethodNameAndType().equals("freeMemory()J")) {
			coder.add("KESO_CURRENT_DOMAIN->heap_free");
		} else return false;

		return true;
	}

	public boolean ignoreMethodBody(IMClass clazz, IMMethod method)
		throws CompileException {
		return true;
	}
}
