/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package keso.util;

import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;

public final class SplitKeyHashMultimap<K1, K2, V> extends SplitKeyMultimap<K1, K2, V>  {

	@Override
	protected Map<K1, Map<K2, Collection<V>>> createLevel1Map() {
		return new HashMap<K1, Map<K2, Collection<V>>>();
	}

	@Override
	protected Map<K2, Collection<V>> createLevel2Map() {
		return new HashMap<K2, Collection<V>>();
	}

	@Override
	protected Collection<V> createCollection() {
		return new HashSet<V>();
	}

}
