#!/usr/bin/perl
# /**(c)
# 
#   Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt
# 
#   This file is part of the KESO Java Runtime Environment.
# 
#   KESO is free software: you can redistribute it and/or modify it under the
#   terms of the Lesser GNU General Public License as published by the Free
#   Software Foundation, either version 3 of the License, or (at your option)
#   any later version.
# 
#   KESO is distributed in the hope that it will be useful, but WITHOUT ANY
#   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#   FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
#   more details. You should have received a copy of the GNU Lesser General
#   Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.
# 
#   Please contact keso@cs.fau.de for more info.
# 
#   (c)**/

%nodes=(
    'IMPhi' => 'IMNode',
    'IMConstant' => 'IMNode',
    'IMReadArray' => 'IMNode',
    'IMReadLocalVariable' => 'IMNode',
    'IMStoreArray' => 'IMNode',
    'IMStoreLocalVariable' => 'IMNode',
    'IMArrayLength' => 'IMNode',
    'IMCall' => 'IMBranch',
    'IMCast' => 'IMUnaryNode',
    'IMStackOperationPOP' => 'IMNode',
    'IMStackOperationPOP2' => 'IMNode',
    'IMStackOperationDUP' => 'IMNode',
    'IMStackOperationDUP_X1' => 'IMNode',
    'IMStackOperationDUP_X2' => 'IMNode',
    'IMStackOperationDUP2' => 'IMNode',
    'IMStackOperationDUP2_X1' => 'IMNode',
    'IMStackOperationDUP2_X2' => 'IMNode',
    'IMStackOperationSWAP' => 'IMNode',
    'IMCastD2F' => 'IMCast',
    'IMCastD2I' => 'IMCast',
    'IMCastD2L' => 'IMCast',
    'IMCastF2D' => 'IMCast',
    'IMCastF2I' => 'IMCast',
    'IMCastF2L' => 'IMCast',
    'IMCastI2B' => 'IMCast',
    'IMCastI2C' => 'IMCast',
    'IMCastI2D' => 'IMCast',
    'IMCastI2F' => 'IMCast',
    'IMCastI2L' => 'IMCast',
    'IMCastI2S' => 'IMCast',
    'IMCastL2D' => 'IMCast',
    'IMCastL2F' => 'IMCast',
    'IMCastL2I' => 'IMCast',
    'IMCaughtException' => 'IMNode',
    'IMCheckCast' => 'IMUnaryNode',
    'IMAdd' => 'IMBinaryNode',
    'IMDiv' => 'IMBinaryNode',
    'IMCompare' => 'IMBinaryNode',
    'IMDGCompare' => 'IMCompare',
    'IMDLCompare' => 'IMCompare',
    'IMFGCompare' => 'IMCompare',
    'IMFLCompare' => 'IMCompare',
    'IMLCompare' => 'IMCompare',
    'IMMul' => 'IMBinaryNode',
    'IMNeg' => 'IMUnaryNode',
    'IMRem' => 'IMBinaryNode',
#    'IMReturn' => 'IMNode',
    'IMEpilog' => 'IMNode',
    'IMSub' => 'IMBinaryNode',
    'IMEQConditionalBranch' => 'IMConditionalBranch',
    'IMGEConditionalBranch' => 'IMConditionalBranch',
    'IMGTConditionalBranch' => 'IMConditionalBranch',
    'IMLEConditionalBranch' => 'IMConditionalBranch',
    'IMLTConditionalBranch' => 'IMConditionalBranch',
    'IMNEConditionalBranch' => 'IMConditionalBranch',
    'IMGetField' => 'IMFieldRead',
    'IMGetStatic' => 'IMFieldRead',
    'IMGoto' => 'IMBranch',
    'IMBitAnd' => 'IMBinaryNode',
    'IMBitOr' => 'IMBinaryNode',
    'IMBitXor' => 'IMBinaryNode',
    'IMShiftLeft' => 'IMBinaryNode',
    'IMShiftRight' => 'IMBinaryNode',
    'IMShiftRight2' => 'IMBinaryNode',
    'IMInstanceOf' => 'IMNode',
    'IMInvoke' => 'IMNode',
    'IMInvokeInterface' => 'IMInvokeNonUnique',
    'IMInvokeSpecial' => 'IMInvokeUnique',
    'IMInvokeStatic' => 'IMInvokeUnique',
    'IMInvokeVirtual' => 'IMInvokeNonUnique',
    'IMLookupSwitch' => 'IMBranch',
    'IMMonitor' => 'IMNode',
    'IMNew' => 'IMAllocation',
    'IMNewArray' => 'IMAllocation',
    'IMNewMultiArray' => 'IMAllocation',
    'IMNewObjArray' => 'IMAllocation',
    'IMPopReturnAddr' => 'IMNode',
    'IMPutField' => 'IMFieldWrite',
    'IMPutStatic' => 'IMFieldWrite',
    'IMReturnSubroutine' => 'IMBranch',
    'IMTableSwitch' => 'IMBranch',
    'IMThrow' => 'IMNode',
    'IMAConstant' => 'IMConstant',
    'IMAMemConstant' => 'IMConstant',
    'IMAMTConstant' => 'IMConstant',
    'IMAMTConstantStatic' => 'IMAMTConstant',
    'IMAObjConstant' => 'IMConstant',
    'IMAReadArray' => 'IMReadArray',
    'IMAReadLocalVariable' => 'IMReadLocalVariable',
    'IMAStoreArray' => 'IMStoreArray',
    'IMAStoreLocalVariable' => 'IMStoreLocalVariable',
    'IMBReadArray' => 'IMReadArray',
    'IMBStoreArray' => 'IMStoreArray',
    'IMCReadArray' => 'IMReadArray',
    'IMCStoreArray' => 'IMStoreArray',
    'IMDAdd' => 'IMAdd',
    'IMDConstant' => 'IMConstant',
    'IMDDiv' => 'IMDiv',
    'IMDMul' => 'IMMul',
    'IMDNeg' => 'IMNeg',
    'IMDReadArray' => 'IMReadArray',
    'IMDReadLocalVariable' => 'IMReadLocalVariable',
    'IMDRem' => 'IMRem',
#    'IMDReturn' => 'IMReturn',
    'IMDStoreArray' => 'IMStoreArray',
    'IMDStoreLocalVariable' => 'IMStoreLocalVariable',
    'IMDSub' => 'IMSub',
    'IMFAdd' => 'IMAdd',
    'IMFConstant' => 'IMConstant',
    'IMFDiv' => 'IMDiv',
    'IMFMul' => 'IMMul',
    'IMFNeg' => 'IMNeg',
    'IMFReadArray' => 'IMReadArray',
    'IMFReadLocalVariable' => 'IMReadLocalVariable',
    'IMFRem' => 'IMRem',
#    'IMFReturn' => 'IMReturn',
    'IMFStoreArray' => 'IMStoreArray',
    'IMFStoreLocalVariable' => 'IMStoreLocalVariable',
    'IMFSub' => 'IMSub',
    'IMIAdd' => 'IMAdd',
    'IMIBitAnd' => 'IMBitAnd',
    'IMIBitOr' => 'IMBitOr',
    'IMIBitXor' => 'IMBitXor',
    'IMIConstant' => 'IMConstant',
    'IMIDiv' => 'IMDiv',
    'IMIMul' => 'IMMul',
    'IMINeg' => 'IMNeg',
    'IMIReadArray' => 'IMReadArray',
    'IMIReadLocalVariable' => 'IMReadLocalVariable',
    'IMIRem' => 'IMRem',
#    'IMIReturn' => 'IMReturn',
#    'IMAReturn' => 'IMReturn',
    'IMIShiftLeft' => 'IMShiftLeft',
    'IMIShiftRight' => 'IMShiftRight',
    'IMIShiftRight2' => 'IMShiftRight2',
    'IMIStoreArray' => 'IMStoreArray',
    'IMIStoreLocalVariable' => 'IMStoreLocalVariable',
    'IMISub' => 'IMSub',
    'IMLAdd' => 'IMAdd',
    'IMLBitAnd' => 'IMBitAnd',
    'IMLBitOr' => 'IMBitOr',
    'IMLBitXor' => 'IMBitXor',
    'IMLConstant' => 'IMConstant',
    'IMLDiv' => 'IMDiv',
    'IMLMul' => 'IMMul',
    'IMLNeg' => 'IMNeg',
    'IMLReadArray' => 'IMReadArray',
    'IMLReadLocalVariable' => 'IMReadLocalVariable',
    'IMLRem' => 'IMRem',
#    'IMLReturn' => 'IMReturn',
    'IMLShiftLeft' => 'IMShiftLeft',
    'IMLShiftRight' => 'IMShiftRight',
    'IMLShiftRight2' => 'IMShiftRight2',
    'IMLStoreArray' => 'IMStoreArray',
    'IMLStoreLocalVariable' => 'IMStoreLocalVariable',
    'IMLSub' => 'IMSub',
    'IMNullConstant' => 'IMConstant',
    'IMSReadArray' => 'IMReadArray',
    'IMSStoreArray' => 'IMStoreArray',
#    'IMVReturn' => 'IMReturn',
); # end %nodes

@typedVisitorExtraTypes = ("IMAllocation", "IMNullCheck");

%trans = (
);

require "templates/typeinfo.pm";
require "templates/init.pm";
require "templates/copyNode.pm";
require "templates/visitNode.pm";
require "templates/costs.pm";
require "templates/processStack.pm";
require "templates/readableString.pm";
require "templates/translate.pm";
require "templates/extras.pm";
require "templates/checks.pm";
require "templates/dumpBC.pm";
require "templates/flowAnalysis.pm";
require "templates/ssa_optimizer.pm";

if ($ARGV[0] eq 'clear') {
       print "createNodes.pl: Removing automatically generated source files.\n";
       foreach $k (keys %nodes) {
               unlink "builder/keso/compiler/imcode/$k.java";
	       unlink "buildstamps/stamp-imclasses";
       }
       exit 0;
}
print "createNodes.pl: Generating sources of intermediate classes.\n";
open STAMP, ">buildstamps/stamp-imclasses" || die "xxx\n";
open GITIGNORE, ">builder/keso/compiler/imcode/.gitignore" || die "could not open imcode/.gitignore";
print GITIGNORE ".gitignore\n";

print GITIGNORE "IMTypedVisitor.java\n";
open TYPEDVISITOR, ">builder/keso/compiler/imcode/IMTypedVisitor.java" || die "Couldn't open IMTypedVisitor.java for writing.\n";
print TYPEDVISITOR <<ENDOFFILE
package keso.compiler.imcode;

import keso.compiler.CompileException;

/* THIS FILE IS GENERATED FROM createNodes.pl */
/**
 * Interface of the visitor pattern implementing a way to call different methods
 * for different node types without using large cascades of instanceof. You
 * should probably not implement this interface directly, but rather subclass
 * one of its implementing adapter classes, e.g. IMTypedVisitorSimpleAdapter,
 * which provides all required methods without implementation. This allows you
 * to override the methods you need to specialize without cluttering your
 * visitor class with all the other methods required by this interface.
 */
public interface IMTypedVisitor {
ENDOFFILE
;

foreach $k (@typedVisitorExtraTypes) {
	my $typedVisitorMethod = "\tpublic void visit(%CLASS% n) throws CompileException;\n";
	$typedVisitorMethod =~ s/\%CLASS\%/$k/gs;
	print TYPEDVISITOR "$typedVisitorMethod";
}

foreach $k (keys %nodes) {

	open OUT, ">builder/keso/compiler/imcode/$k.java" || die "xxx\n";
	print STAMP "builder/keso/compiler/imcode/$k.java\n";
	print GITIGNORE "$k.java\n";

	print OUT <<ENDOFFILE

package keso.compiler.imcode;

import keso.classfile.*;
import keso.classfile.constantpool.*;
import keso.classfile.datatypes.*;

import keso.compiler.*;
import keso.compiler.analysis.*;
import keso.compiler.analysis.connectiongraph.*;
import keso.compiler.backend.*;
import keso.compiler.kni.*;

import keso.util.IntegerHashtable;

ENDOFFILE
;
	print OUT "\n/* AUTO-GENERATED FILE - DON'T EDIT */\n\n";

	my $type = $itypes{$k};

	print OUT "public class $k extends $nodes{$k} {\n\n";

	if ($stack{$k.'-vars'}) { print OUT "\t".$stack{$k.'-vars'}."\n"; }

	my $init_method = $init_imnode;
	if ($init{$k}=~/CLASS/) { $init_method = $init{$k}; }
	$init_method="\n\t/* copy constructor */\n\tprotected \%CLASS\%() { }\n".$init_method;
	if ($init_method=~/domainID/) {
		$init_method=~s/\%DOMID\%/\n\t\tint domainID=0;/gs;
	} else {
		$init_method=~s/\%DOMID\%//gs;
	}
	$init_method=~s/\%CLASS\%/$k/gs;
	$init_method=~s/\%BCTYPE\%/$bctypes{$type}/gs;
	$init_method=~s/\%JTYPE\%/$jtypes{$type}/gs;
	$init_method=~s/\%UJTYPE\%/$jtypes_uppercase{$type}/gs;
	print OUT "$init_method\n";

	if ($copyNode{$k}) {
		print OUT "\t\@Override\n";
		my $copyNode_method="\tpublic IMNode copy(IMCopyVisitor visitor)";
		$copyNode_method.= " throws CompileException {";
		$copyNode_method.= $copyNode{$k}."\n";
		$copyNode_method.="\t\tif (visitor==null) return nnode;\n";
		$copyNode_method.="\t\treturn visitor.visit(nnode,this);\n\t}\n\n";

		$copyNode_method=~s/\%CLASS\%/$k/gs;
		$copyNode_method=~s/\%BCTYPE\%/$bctypes{$type}/gs;
		$copyNode_method=~s/\%JTYPE\%/$jtypes{$type}/gs;
		print OUT "$copyNode_method";
	}

	if ($visitNode{$k}) {
		print OUT "\t\@Override\n";
		my $visitNode_method="\tfinal public void visitNodes(IMVisitor visitor)";
		$visitNode_method.=" throws CompileException {";
		$visitNode_method.="\n\t\tif (visitor.skipNode(this)) return;";
		$visitNode_method.= $visitNode{$k}."\n";
		$visitNode_method.="\t}\n\n";

		$visitNode_method=~s/\%CLASS\%/$k/gs;
		$visitNode_method=~s/\%BCTYPE\%/$bctypes{$type}/gs;
		$visitNode_method=~s/\%JTYPE\%/$jtypes{$type}/gs;
		print OUT "$visitNode_method";
	}

	# typed visitor
	my $typedVisitorMethod = "\tpublic void visit(%CLASS% n) throws CompileException;\n";
	$typedVisitorMethod =~ s/\%CLASS\%/$k/gs;
	print TYPEDVISITOR "$typedVisitorMethod";

	print OUT "\tpublic void accept(IMTypedVisitor visitor) throws CompileException {\n";
	print OUT "\t\tvisitor.visit(this);\n";
	print OUT "\t}\n\n";

	if ($ssa_optimize{$k}) {
		print OUT "\t\@Override\n";
		my $ssa_opt_method="\tfinal public IMNode ssa_optimize()";
		$ssa_opt_method.=" throws CompileException {";
		#$ssa_opt_method.="\n\t\topts.verbose(\"ssa: \"+toReadableString());\n";
		if ($ssa_optimize{$k}=~/basicBlock/) {
			$ssa_opt_method.="\n\t\tIMBasicBlock basicBlock = method.getCurrentBasicBlock();\n";
			$ssa_opt_method.="\t\tif (basicBlock==null) throw new CompileException(\"no bb in \"+method.getAlias());\n";
		}
		$ssa_opt_method.= $ssa_optimize{$k}."\n";
		$ssa_opt_method.=$constant_swap if ($kommutativ{$k} ne '');
		my $n_elem = $ssa_neutral_elem{$k};
		my $c_elem = $ssa_clear_elem{$k};
		if ($n_elem ne '' || $c_elem ne '') {
			$ssa_opt_method.="\n\t\tif (rOpr.isConstant()) {";
			$ssa_opt_method.="\n\t\t\t\%JTYPE\% value = rOpr.nodeToConstant().get\%UJTYPE\%Value();";
			if ($n_elem ne '') {
				$ssa_opt_method.="\n\t\t\tif (value==".$n_elem.") {";
				$ssa_opt_method.="\n\t\t\t\topts.vverbose(\"++ folding x_c x\%BIN_OP\%c \"+toReadableString()+\" -> \"+lOpr.toReadableString());";
				$ssa_opt_method.="\n\t\t\t\treturn lOpr;";
				$ssa_opt_method.="\n\t\t\t}";
			}
			if ($c_elem ne '') {
				$ssa_opt_method.="\n\t\t\tif (value==".$c_elem.") {";
				$ssa_opt_method.="\n\t\t\t\topts.vverbose(\"++ folding x_c x\%BIN_OP\%c \"+toReadableString()+\" -> $c_elem\");";
				$ssa_opt_method.="\n\t\t\t\treturn method.createIM".$itypes{$k};
				$ssa_opt_method.="Constant(".$c_elem.", bcPosition);";
				$ssa_opt_method.="\n\t\t\t}";
			}
			if ($ssa_associative{$k}) {
				$ssa_opt_method.="\n\t\t\tif (lOpr.hasConstant() && lOpr instanceof $k) {";
				$ssa_opt_method.="\n\t\t\t\tIMConstant lrOpr = lOpr.getRightNode().nodeToConstant();";
				$ssa_opt_method.="\n\t\t\t\t\%JTYPE\% lrvalue = lrOpr.get\%UJTYPE\%Value();";
				$ssa_opt_method.="\n\t\t\t\tlrOpr.set\%UJTYPE\%Value((lrvalue \%BIN_OP\% value));";
				$ssa_opt_method.="\n\t\t\t\topts.vverbose(\"+- folding x_c ((x\%BIN_OP\%\"+lrvalue+\")\%BIN_OP\%\"+value+\") -> \"+lOpr.toReadableString());";
				$ssa_opt_method.="\n\t\t\t\treturn lOpr;";
				$ssa_opt_method.="\n\t\t\t}";
			}
			$ssa_opt_method.="\n\t\t\topts.vverbose(\"-- folding x_c x\%BIN_OP\%c \"+toReadableString());";
			$ssa_opt_method.="\n\t\t}\n";
		}
		$ssa_opt_method.="\n\t\treturn this;\n";
		$ssa_opt_method.="\t}\n\n";

		$ssa_opt_method=~s/\%CLASS\%/$k/gs;
		$ssa_opt_method=~s/\%STYPE\%/$type/gs;
		$ssa_opt_method=~s/\%JTYPE\%/$jtypes{$type}/gs;
		$ssa_opt_method=~s/\%UJTYPE\%/$jtypes_uppercase{$type}/gs;
		$ssa_opt_method=~s/\%CONDITION\%/$ssa_condition{$k}/gs;

		$ssa_opt_method=~s/\%BIN_OP\%/$bin_op{$k}/gs if $bin_op{$k};

		print OUT "$ssa_opt_method";
	}

	if ($extra{$k}) {
		my $ext = $extra{$k};
		$ext=~s/\%CLASS\%/$k/gs;
		print OUT $ext;
	}

	if ($evaluate{$k}) {
		my $evaluateMethod = "\t\@Override\n";
		$evaluateMethod .= "\tfinal public IMConstant evaluate(IMConstant... args) {\n";
		$evaluateMethod .= "$evaluate{$k}\n";
		$evaluateMethod .= "\t}\n";
		$evaluateMethod =~ s/\%STYPE\%/$type/gs;
		$evaluateMethod =~ s/\%NSTYPE\%/$ntypes{$type}/gs;
		$evaluateMethod =~ s/\%JTYPE\%/$jtypes{$type}/gs;
		$evaluateMethod =~ s/\%UJTYPE\%/$jtypes_uppercase{$type}/gs;
		$evaluateMethod =~ s/\%BIN_OP\%/$bin_op{$k}/gs if $bin_op{$k};
		print OUT "$evaluateMethod\n";
	}

	if ($evaluateMin{$k}) {
		my $evalMinMethod = "\t\@Override\n";
		$evalMinMethod .= "\tfinal public Integer evaluateMin(Integer... limits) {\n";
		$evalMinMethod .= "$evaluateMin{$k}\n";
		$evalMinMethod .= "\t}\n";
		$evalMinMethod =~ s/\%STYPE\%/$type/gs;
		$evalMinMethod =~ s/\%NSTYPE\%/$ntypes{$type}/gs;
		$evalMinMethod =~ s/\%JTYPE\%/$jtypes{$type}/gs;
		$evalMinMethod =~ s/\%UJTYPE\%/$jtypes_uppercase{$type}/gs;
		$evalMinMethod =~ s/\%BIN_OP\%/$bin_op{$k}/gs if $bin_op{$k};
		print OUT "$evalMinMethod\n";
	}

	if ($evaluateMax{$k}) {
		my $evalMaxMethod = "\t\@Override\n";
		$evalMaxMethod .= "\tfinal public Integer evaluateMax(Integer... limits) {\n";
		$evalMaxMethod .= "$evaluateMax{$k}\n";
		$evalMaxMethod .= "\t}\n";
		$evalMaxMethod =~ s/\%STYPE\%/$type/gs;
		$evalMaxMethod =~ s/\%NSTYPE\%/$ntypes{$type}/gs;
		$evalMaxMethod =~ s/\%JTYPE\%/$jtypes{$type}/gs;
		$evalMaxMethod =~ s/\%UJTYPE\%/$jtypes_uppercase{$type}/gs;
		$evalMaxMethod =~ s/\%BIN_OP\%/$bin_op{$k}/gs if $bin_op{$k};
		print OUT "$evalMaxMethod\n";
	}

	if ($stack{$k}) {
		print OUT "\t\@Override\n";
		print OUT "\tpublic IMNode processStack(VirtualOperandStack stack, IMNode extra_ops) throws CompileException {";
		print OUT "\n\t\tIMBasicBlock basicBlock = method.getCurrentBasicBlock();\n" if $stack{$k}=~/basicBlock/;
		print OUT $stack{$k};
		print OUT "\t}\n\n";
	}

	print OUT $trans{$k} if $trans{$k};

	if ($readable{$k}) {
		print OUT "\t\@Override\n";
		print OUT "\tpublic String toReadableString() {";
		print OUT $readable{$k};
		print OUT "\t}\n\n";
	}

	if ($check{$k}) {
		print OUT "\tprotected boolean needsCheck = true;\n";
		print OUT "\n";
		print OUT "\t\@Override\n";
		print OUT "\tpublic final boolean hasToBeChecked() {\n";
		print OUT "\t\treturn needsCheck;\n";
		print OUT "\t}\n";
		print OUT "\n";
		print OUT "\t\@Override\n";
		print OUT "\tpublic void emitCheck(IMNode checkList, IMBasicBlock successor)\n";
		print OUT "\tthrows CompileException {\n";
		print OUT "$check{$k}\n";
		print OUT "\t\tneedsCheck = false;\n";
		print OUT "\t}\n";
		print OUT "\n";
	}

	if ($dumpbc{$k}) {
		print OUT "\t\@Override\n";
		print OUT "\tpublic String dumpOperands() {\n";
		print OUT "\t\t$dumpbc{$k}\n";
		print OUT "\t}\n\n";
	}

	if ($costs{$k}) {
		print OUT "\t\@Override\n";
		my $costs_method="\tpublic int costs() throws CompileException {";
		$costs_method.= $costs{$k};
		$costs_method.="\n\t}\n\n";
		print OUT "$costs_method";
	}

	my $trans_code = $translate{$k};
	if ($trans_code) {
		print OUT "\t\@Override\n";
		print OUT "\tpublic void translate(Coder coder) throws CompileException {";
		print OUT "\n\t\tIMBasicBlock basicBlock = method.getCurrentBasicBlock();\n" if $trans_code=~/basicBlock/;
		print OUT "\n\t\tIMMethodFrame frame = method.getMethodFrame();\n" if $trans_code=~/frame/;
		print OUT $trans_code;
		print OUT "\t}\n\n";
	}

	print OUT "}\n";

	close OUT;
}

print TYPEDVISITOR "}\n";
close TYPEDVISITOR;

close STAMP;
close GITIGNORE;
