/*KESO--HEADER--KESO*/
/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
#ifdef KESO_PRODUCTION
#  define KESO_THROW_ERROR(_msg_) keso_throw_error()
void 	keso_throw_error(void);

#else
#  define KESO_THROW_ERROR(_msg_) keso_throw_error(_msg_)
void keso_throw_error(const char *msg);
#endif

#ifdef DEBUG
#	 define QUOTE(X) #X
#  define KESO_ASSERT(__v__) if (!(__v__)) keso_throw_error("Assertion failed in " __FILE__ QUOTE(__LINE__))
#else
#  define KESO_ASSERT(__v__)
#endif

/*KESO--CFILE--KESO*/
#ifdef KESO_PRODUCTION
void 	keso_throw_error(void) {
	ShutdownOS(E_NOT_OK);
}

#else
void keso_throw_error(const char *msg) {
	KESO_PRINTF("%s\n", msg);
	ShutdownOS(E_NOT_OK);
}
#endif

