/*KESO--HEADER--KESO*/
/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
jint keso_fp_dmul(jint a, jint b);

/*KESO--CFILE--KESO*/

jint keso_fp_dmul(jint a, jint b) {
	char sign;
	unsigned long int t;

	sign = ((a < 0 && b < 0) || (b > 0 && a > 0)) ? 1 : 0;

	a = KESO_FP_ABS(a);
	b = KESO_FP_ABS(b);

	t = (((unsigned long int)a * (unsigned long int)b) + (1<<(KESO_FP_QD-1))) >> KESO_FP_QD;

	if (0xffffffff00000000LL & t)
		return (jint)(sign?KESO_FP_DMAX:KESO_FP_DMIN);

	return (sign?(jint)t:-((jint)t));
}
