/*KESO--HEADER--KESO*/
/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

void dump_bitmap(void);
void dump_obj(object_t* addr);

/*KESO--CFILE--KESO*/
#include <stdio.h>

void dump_bitmap(void) {
	int i;
	for (i=0;i<(COFFEE_HEAPDESC.numslots>>5);i++) {
		KESO_PRINTF(" %X",keso_gc_bitmap[i]);
	}
	KESO_PRINTF("\n");
}

void dump_obj(object_t* addr) {
	class_id_t clsid;
	unsigned int bit,color,i,slot;

	if (addr==NULL) {
		KESO_PRINTF("addr : (null)\n");
		return ;
	}

	KESO_PRINTF("addr : 0x%x\n",addr);
	clsid = addr->class_id;
	if (clsid<1 || (KESO_CLASSSTORE_SIZE+1)<clsid) {
		KESO_PRINTF("class: %d (invalid)\n",clsid);
	} else {
		KESO_PRINTF("class: %d",clsid);
		if (keso_isArrayClass(clsid)) {
			if (keso_isObjectArrayClass(clsid)) {
				KESO_PRINTF(" (obj array)\n");
			} else {
				KESO_PRINTF(" (array)\n");
			}
			KESO_PRINTF("size : %d byte",sizeof(array_t)+CLASS(clsid).size*((array_t*)addr)->size);
		} else {
			if (keso_isMemoryClass(clsid)) {
				KESO_PRINTF(" (memory proxy)\n");
			} else {
				KESO_PRINTF(" (obj)\n");
			}
			KESO_PRINTF("size : %d byte",CLASS(clsid).size);
		}
		KESO_PRINTF(" %d slots\n",objSize(addr));
	}

	slot = COFFEE_ADDR2SLOT(addr);
	if (slot<0 || slot>=COFFEE_HEAPDESC.numslots) {
		KESO_PRINTF("bmap : (not on heap)\n");
	} else {
		KESO_PRINTF("bmap : %d ",slot);
		for (i=0;i<objSize(addr);i++) {
			int bm_int = slot+i >> 5;
			int bm_bit = 1 << ((slot+i) & 0x1f);
			KESO_PRINTF("%d",keso_gc_bitmap[bm_int]&bm_bit);
		}
		KESO_PRINTF("\n");
	}
	color = OBJCOLORED(addr);
	KESO_PRINTF("cbit : %s\n",(color?"grey/black":"white"));
}

