/*KESO--HEADER--KESO*/
/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

jint keso_castD2I(jdouble value) ATTR_CONST;
jlong keso_castD2L(jdouble value) ATTR_CONST;

jint keso_dcmpg(jdouble a, jdouble b) ATTR_CONST;
jint keso_dcmpl(jdouble a, jdouble b) ATTR_CONST;

/*KESO--CFILE--KESO*/

#ifdef __BIG_ENDIAN
__huge_val_t __huge_val = { { 0x7f, 0x80, 0, 0 } };
__huge_val_t __nan_val  = { { 0x7f, 0xc0, 0, 0 } };
#else
__huge_val_t __huge_val = { { 0, 0, 0x80, 0x7f } };
__huge_val_t __nan_val  = { { 0, 0, 0xc0, 0x7f } };
#endif

jint keso_castD2I(jdouble value) {
	return (jint)value;
}

jlong keso_castD2L(jdouble value) {
	return (jlong)value;
}

jint keso_dcmpg(jdouble a, jdouble b) {
	if (a>b) return 1;
	if (a==b) return 0;
	if (a<b) return -1;
	return 1;
}

jint keso_dcmpl(jdouble a, jdouble b) {
	if (a>b) return 1;
	if (a==b) return 0;
	if (a<b) return -1;
	return -1;
}
