/*KESO--HEADER--KESO*/
/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

#ifdef KESO_HAS_DYN_SHARED_MEMORY
object_t* keso_dup_mem(object_t* obj);
#else
/* immortal proxy object is shared
 * without reference counter */
#define keso_dup_mem(_obj_) ((object_t*)_obj_)
#endif

/*KESO--CFILE--KESO*/

#ifdef KESO_HAS_DYN_SHARED_MEMORY
object_t* keso_dup_mem(object_t* obj) {
	char* mem = KESO_MEMORY_ADDR(obj);
	if (keso_is_shared_memory(mem)) {
		/* create new proxy object for memory region */
		object_t *mem_obj = keso_allocObject(KESO_MEMORY_ID);

		/* increase reference counter */
		keso_require_shared_memory(mem);

		/* init new proxy object */
		KESO_MEMORY_ADDR(mem_obj) = mem;
		KESO_MEMORY_SIZE(mem_obj) = KESO_MEMORY_SIZE(obj);

		return mem_obj;
	} else {
		/* immortal proxy object is shared
		 * without reference counter */
		return obj;
	}
}
#endif

