/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package keso.driver.avr.atmega128;

public class Spi {
	static {
		/*Setup Spi interface*/
		ATMega128.registers.DDRB.setBit(ATMega128.DDB3); //MISO as an output
		ATMega128.registers.PORTB.setBit(ATMega128.PB3); //MISO high
		ATMega128.registers.PORTB.setBit(ATMega128.SPE); //enable spi
	}

	public static void enable_all() {
		ATMega128.registers.DDRB.setBit(ATMega128.DDB3); //MISO as an output
                ATMega128.registers.PORTB.setBit(ATMega128.PB3); //MISO high
                enable_irq();
		ATMega128.registers.PORTB.setBit(ATMega128.SPE); //enable spi
	}

	public static void disable_all() {
                disable_irq();
                ATMega128.registers.PORTB.clearBit(ATMega128.SPE); //disable spi
        }


	public static void enable_irq() {
		ATMega128.registers.SPCR.setBit(ATMega128.SPIE);
		ATMega128.registers.DDRB.clearBit(ATMega128.DDB1); //SCK as an input
	}

	public static void disable_irq() {
		ATMega128.registers.SPCR.clearBit(ATMega128.SPIE);
		ATMega128.registers.DDRB.setBit(ATMega128.DDB1); //SCK as an output
                ATMega128.registers.PORTB.clearBit(ATMega128.PB1); //SCK low

	}

	public static void rx_mode() {
		ATMega128.registers.DDRB.clearBit(ATMega128.DDB3); //MISO as an intput
		ATMega128.registers.DDRB.clearBit(ATMega128.DDB2); //MOSI as an intput
	}

	public static void tx_mode() {
                ATMega128.registers.DDRB.setBit(ATMega128.DDB3); //MISO as an output
		ATMega128.registers.DDRB.setBit(ATMega128.DDB2); //MOSI as an output
        }

	public static byte read() {
		byte data;

	//	while(!(ATMega128.registers.SPSR.isBitSet(ATMega128.SPIF)));
		data = (byte) ATMega128.registers.SPDR.get();

		return (byte) data;
	}

	public static byte write(byte data) {
		byte read;

		ATMega128.registers.SPDR.set(data);
		//while(!(ATMega128.registers.SPSR.isBitSet(ATMega128.SPIF)));

		read = (byte) ATMega128.registers.SPDR.get();

		return read;
	}
	/*public static void write(byte data) {

                ATMega128.registers.SPDR.set(data);
                //while(!(ATMega128.registers.SPSR.isBitSet(ATMega128.SPIF)));

	}*/
}
