/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package keso.driver.avr.atmega32;


import keso.driver.avr.atmega32.ATMega32;

/**
 *
 */

public class ADC {

	/**
	 */
	static {
          ATMega32.registers.DDRA.and(~0x70);
          ATMega32.registers.PORTA.and(~0x70);
          ATMega32.registers.ADCSRA.set(0);

          ATMega32.registers.ADCSRA.or(1<<ATMega32.ADEN); //ADC einschalten (vgl. Manual S.216)
          ATMega32.registers.ADCSRA.or((1<<ATMega32.ADPS0)|(1<<ATMega32.ADPS1)|(1<<ATMega32.ADPS2)); //Prescaler 128

          //AVCC als Referenzspannung setzen (vgl. Manual S.214)
          ATMega32.registers.ADMUX.set(0);
          ATMega32.registers.ADMUX.or(1<<ATMega32.REFS0);


      }
      /*
       *ADC Kanaele:
       */
	static volatile int tmp;
       public static long sample(int channel) {
       long erg = 0;
       long lower = 0;
       long higher = 0;
       channel = channel & 0x0f;
       ATMega32.registers.ADMUX.and(~0x0f); //Pin, an dem gelesen werden soll, einstellen (vgl. Manual S. 214)
       ATMega32.registers.ADMUX.or(channel);

	  //"Probeeinlesen", um fehler zu vermeiden
          while( (ATMega32.registers.ADCSRA.get()&(1<<ATMega32.ADSC)) > 0)tmp++; //warten, bis einlesen fertig
          lower = ATMega32.registers.ADCL.get(); //WICHTIG erst ADCL auslesen!
          higher = ATMega32.registers.ADCH.get();//Dann ADCH

	//for(int i = 0; i < 4; i++){
          ATMega32.registers.ADCSRA.or(1<<ATMega32.ADSC); //Einlesevorgang starten (vgl. Manual S. 216)
          while( (ATMega32.registers.ADCSRA.get()&(1<<ATMega32.ADSC)) > 0)tmp++; //warten, bis einlesen fertig
          lower = ATMega32.registers.ADCL.get(); //WICHTIG erst ADCL auslesen!
          higher = ATMega32.registers.ADCH.get();//Dann ADCH
          erg = (long)(lower |  ((higher & 0x03 ) << 8));//Ergebnis berechnen
	//}
          return erg;

	}



}


