/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package keso.driver.avr.atmega8535;

/**
 *
 * @author Ralf Ellner
 */
public final class Adc {

    static {

        ATMega8535.registers.ADCSRA.set((1 << ATMega8535.ADEN) | (1 << ATMega8535.ADPS2) | (1 << ATMega8535.ADPS1) | (1 << ATMega8535.ADPS0));

    }

    public static short getValue(byte channel) {

        short ret;

        // select input channel
        ATMega8535.registers.ADMUX.set((ATMega8535.registers.ADMUX.get() & 0xf8) | (channel & 0x07));

        // start conversion
        // a conversion takes 13 ADC-cycles, i.e. 0.1ms for 115.2kHz ADC-clock
        // the very first conversion after switching on the ADS takes 25 ADC cycles
        ATMega8535.registers.ADCSRA.setBit(ATMega8535.ADSC);

        // wait for conversion to finish
        while ((ATMega8535.registers.ADCSRA.get() & (1 << ATMega8535.ADIF)) == 0);

        // read ADCL and then ADCH
        ret = (short) ATMega8535.registers.ADCL.get();
        ret |= (ATMega8535.registers.ADCH.get() << 8);

        return ret;

    }

}
