/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package ciao;

/**
 * This class contains the config variables from the CiAO KConfig configuration
 * that are available in cfAttribs.h in CiAO.
 */
public final class CiAOConfig {
	private CiAOConfig() {}

	public static final boolean run_global_constructors = true;
	public static final boolean lib_libcmini = true;
	public static final boolean lib_osekcompat = true;
	public static final boolean ciao_platform_test_t32_files = true;
	public static final boolean dev = true;
	public static final boolean dev_busses = true;
	public static final boolean dev_busses_asc = true;
	public static final int cfDEV_ASC_BAUD = 9600;
	public static final boolean dev_asc0 = true;
	public static final boolean dev_misc = true;
	public static final boolean dev_stm = true;
	public static final boolean dev_net = true;
	public static final boolean dev_lan91 = true;
	public static final long cfDEV_LAN91_MACADDR = 0x00023f17d560L;
	public static final boolean hal = true;
	public static final boolean hal_threading = true;
	public static final boolean hal_threading_tcbuser_cleanup = true;
	public static final boolean hal_debugging = true;
	public static final boolean hal_AssertionHandling_simple = true;
	public static final boolean hal_DebugPort = true;
	public static final boolean hal_DebugPort_ipstack_udp = true;
	public static final boolean hal_devices = true;
	public static final boolean hal_Timer0 = true;
	public static final boolean hal_SystemClock = true;
	public static final boolean hal_networking = true;
	public static final boolean hal_networking_single = true;
	public static final boolean hal_networking_single_lan91 = true;
	public static final boolean hal_ast0 = true;
	public static final boolean hal_astimpl_cpu_src0 = true;
	public static final boolean hal_protection = true;
	public static final boolean hal_kernellockimplementation = true;
	public static final boolean hal_kernellockdynamic = true;
	public static final boolean irq_dma_syssrc2 = true;
	public static final boolean irq_ssc0_transmit = true;
	public static final boolean irq_ssc0_error = true;
	public static final boolean irq_dma0 = true;
	public static final boolean irq_cpu_src0 = true;
	public static final boolean trap = true;
	public static final boolean trap_6_ctxmanip = true;
	public static final int cfIRQL_CPU_SRC0 = 1;
	public static final int cfIRQL_DMA0 = 12;
	public static final int cfIRQL_ASC0_REC = 8;
	public static final int cfIRQL_ASC0_TRA = 0;
	public static final int cfIRQL_ASC0_TBUF = 0;
	public static final int cfIRQL_ASC0_ERR = 0;
	public static final int cfIRQL_ASC1_REC = 9;
	public static final int cfIRQL_ASC1_TRA = 0;
	public static final int cfIRQL_ASC1_TBUF = 0;
	public static final int cfIRQL_ASC1_ERR = 0;
	public static final int cfIRQL_STM_SRC0 = 26;
	public static final int cfIRQL_STM_SRC1 = 6;
	public static final int cfIRQL_DMA_SYSSRC2 = 7;
	public static final int cfIRQL_SSC0_TRANSMIT = 10;
	public static final int cfIRQL_SSC0_ERROR = 11;
	public static final int cfIRQ_CAT2_ISR_MAX = 25;
	public static final int cfHW_OSCFREQ = 20000000;
	public static final int cfHW_PLL_NDIV = 60;
	public static final int cfHW_PLL_KDIV = 4;
	public static final int cfHW_PLL_PDIV = 2;
	public static final int cfHW_PLL_SYSDIV = 2;
	public static final int cfHW_STM_DIV = 1;
	public static final boolean board_memory_layout_easyrun_intflash_extram = true;
	public static final boolean memprot = true;
	public static final boolean memprot_w = true;
	public static final boolean memprot_trusted = true;
	public static final boolean memprot_apps = true;
	public static final boolean memprot_data = true;
	public static final boolean memprot_stacks = true;
	public static final boolean kernel_coordination = true;
	public static final boolean kernel_resources = true;
	public static final boolean kernel_pcp = true;
	public static final boolean kernel_events = true;
	public static final int cfOS_MAX_NUMBER_OF_EVENTS_PER_TASK = 8;
	public static final boolean kernel_alarms = true;
	public static final boolean kernel_tasks = true;
	public static final int cfOS_MAX_PRIORITY = 31;
	public static final boolean kernel_fullpreemptive = true;
	public static final boolean kernel_category1isrs = true;
	public static final int cfOS_ISR1_SUPPORT = 1;
	public static final boolean cfOS_ISR2_SUPPORT = true;
	public static final boolean kernel_sharedmemory = true;
	public static final boolean kernel_messageports = true;
	public static final boolean kernel_messageports_senderwriterevocation = true;
	public static final boolean kernel_messageports_receiverwriteaccess = true;
	public static final boolean kernel_oscontrol = true;
	public static final boolean kernel_protectionhookdefault = true;
	public static final boolean kernel_startupshutdownpretaskposttaskhook = true;
	public static final boolean kernel_applications = true;
	public static final boolean ipstack = true;
	public static final boolean ipstack_linklayer_ethernet = true;
	public static final boolean ipstack_ipv4 = true;
	public static final boolean ipstack_ipv4_send = true;
	public static final boolean ipstack_ipv4_recv = true;
	public static final boolean ipstack_ipv4_recv_fragments = true;
	public static final boolean ipstack_arp = true;
	public static final boolean ipstack_arp_ipv4 = true;
	public static final boolean ipstack_arp_ipv4_request = true;
	public static final boolean ipstack_arp_ipv4_reply = true;
	public static final boolean ipstack_arp_timeout = true;
	public static final boolean ipstack_irqsync = true;
	public static final boolean ipstack_clock = true;
	public static final boolean ipstack_autosar_event = true;
	public static final boolean ipstack_autosar_reschudule = true;
	public static final boolean ipstack_autosar_reschudule_arp_ipv4_request = true;
	public static final boolean ipstack_autosar_reschudule_udp_ipv4_send = true;
	public static final boolean ipstack_udp = true;
	public static final boolean ipstack_udp_ipv4 = true;
	public static final boolean ipstack_udp_ipv4_send = true;
	public static final boolean ipstack_udp_ipv4_send_checksum = true;
	public static final boolean ipstack_udp_ipv4_recv = true;
	public static final boolean ipstack_udp_ipv4_recv_checksum = true;
	public static final boolean ipstack_byteorder_little = true;
	public static final int cfIPSTACK_BLOCKSIZE_BIG = 1514;
	public static final int cfIPSTACK_COUNT_BIG = 2;
	public static final int cfIPSTACK_BLOCKSIZE_SMALL = 128;
	public static final int cfIPSTACK_COUNT_SMALL = 2;
	public static final boolean ipstack_ifcfg0 = true;
	public static final int cfIPSTACK_IFCFG0_IP = 0x2222a8c0;
	public static final int cfIPSTACK_IFCFG0_SUBNET = 0xffffff;
	public static final boolean ipstack_udp_debugport = true;
	public static final int cfIPSTACK_UDP_DEBUGPORT_DESTIP = 0x822a8c0;
	public static final int cfIPSTACK_UDP_DEBUGPORT_DESTPORT = 10300;
	public static final boolean task___CopterControlTask___usesComponent___CopterControlComponent = true;
	public static final boolean task___CopterControlTask___schedule___full = true;
	public static final int task___CopterControlTask___activation = 1;
	public static final int task___CopterControlTask___priority = 10;
	public static final int task___CopterControlTask___stacksize = 8192;
	public static final boolean task___CopterControlTelemetryTask___usesComponent___CopterControlComponent = true;
	public static final boolean task___CopterControlTelemetryTask___schedule___full = true;
	public static final int task___CopterControlTelemetryTask___activation = 1;
	public static final int task___CopterControlTelemetryTask___priority = 5;
	public static final int task___CopterControlTelemetryTask___stacksize = 512;
	public static final boolean task___EthernetTask___usesComponent___EthernetComponent = true;
	public static final boolean task___EthernetTask___usesEvent___PacketWaitingEvent = true;
	public static final boolean task___EthernetTask___usesEvent___IPStackReceiveEvent = true;
	public static final boolean task___EthernetTask___schedule___full = true;
	public static final int task___EthernetTask___activation = 1;
	public static final int task___EthernetTask___priority = 7;
	public static final int task___EthernetTask___stacksize = 8192;
	public static final boolean task___FlightControlTask___usesComponent___FlightControlComponent = true;
	public static final boolean task___FlightControlTask___schedule___full = true;
	public static final int task___FlightControlTask___activation = 1;
	public static final int task___FlightControlTask___priority = 12;
	public static final int task___FlightControlTask___stacksize = 8192;
	public static final boolean task___FlightControlTelemetryTask___usesComponent___FlightControlComponent = true;
	public static final boolean task___FlightControlTelemetryTask___schedule___full = true;
	public static final int task___FlightControlTelemetryTask___activation = 1;
	public static final int task___FlightControlTelemetryTask___priority = 4;
	public static final int task___FlightControlTelemetryTask___stacksize = 512;
	public static final boolean task___SPIComTask___usesComponent___SPIComComponent = true;
	public static final boolean task___SPIComTask___usesEvent___SPIEvent = true;
	public static final boolean task___SPIComTask___usesEvent___SPIErrorEvent = true;
	public static final boolean task___SPIComTask___schedule___full = true;
	public static final int task___SPIComTask___activation = 1;
	public static final int task___SPIComTask___priority = 15;
	public static final int task___SPIComTask___stacksize = 8192;
	public static final boolean task___SignalProcessingTask___usesComponent___SignalProcessingComponent = true;
	public static final boolean task___SignalProcessingTask___schedule___full = true;
	public static final int task___SignalProcessingTask___activation = 1;
	public static final int task___SignalProcessingTask___priority = 13;
	public static final int task___SignalProcessingTask___stacksize = 8192;
	public static final boolean task___SignalProcessingTelemetryTask___usesComponent___SignalProcessingComponent = true;
	public static final boolean task___SignalProcessingTelemetryTask___schedule___full = true;
	public static final int task___SignalProcessingTelemetryTask___activation = 1;
	public static final int task___SignalProcessingTelemetryTask___priority = 3;
	public static final int task___SignalProcessingTelemetryTask___stacksize = 512;
	public static final boolean task___restartDMATask___usesComponent___InitTaskComponent = true;
	public static final boolean task___restartDMATask___schedule___full = true;
	public static final int task___restartDMATask___activation = 1;
	public static final int task___restartDMATask___priority = 17;
	public static final int task___restartDMATask___stacksize = 128;
	public static final boolean event___PacketWaitingEvent = true;
	public static final boolean event___IPStackReceiveEvent = true;
	public static final boolean event___SPIEvent = true;
	public static final boolean event___SPIErrorEvent = true;
	public static final boolean event___Get_Telemetry = true;
	public static final boolean osapplication___CopterControlApp___untrusted = true;
	public static final boolean osapplication___EthernetApp___trusted = true;
	public static final boolean osapplication___FlightControlApp___untrusted = true;
	public static final boolean osapplication___InitTaskApp___trusted = true;
	public static final boolean osapplication___SPIComApp___untrusted = true;
	public static final boolean osapplication___SignalProcessingApp___untrusted = true;
	public static final boolean isr___RadioISR___isrUsedByComponent___CopterControlComponent = true;
	public static final int isr___RadioISR___category = 2;
	public static final boolean isr___SPIInterrupt___isrUsedByComponent___SPIComComponent = true;
	public static final int isr___SPIInterrupt___category = 2;
	public static final boolean isr___SPIErrorInterrupt___isrUsedByComponent___SPIComComponent = true;
	public static final int isr___SPIErrorInterrupt___category = 2;
	public static final boolean component___CopterControlComponent___componentRefApp___CopterControlApp = true;
	public static final boolean component___CopterControlComponent___componentRefShm___CopterControl_flightControlApplicationModes_t = true;
	public static final boolean component___CopterControlComponent___componentRefShm___CopterControl_flightControlApplicationModes_t___mode___rw = true;
	public static final boolean component___CopterControlComponent___componentRefShm___Default_CopterControl_basicFlightCtrlData_t = true;
	public static final boolean component___CopterControlComponent___componentRefShm___Default_CopterControl_basicFlightCtrlData_t___mode___rw = true;
	public static final boolean component___CopterControlComponent___componentRefShm___Default_CopterControl_steeringStatusData_t = true;
	public static final boolean component___CopterControlComponent___componentRefShm___Default_CopterControl_steeringStatusData_t___mode___rw = true;
	public static final boolean component___CopterControlComponent___componentRefShm___Default_Ethernet_ethRemoteCtrlData_t = true;
	public static final boolean component___CopterControlComponent___componentRefShm___Default_Ethernet_ethRemoteCtrlData_t___mode___r = true;
	public static final boolean component___CopterControlComponent___componentRefShm___Default_IdleTask_CPUUtilization = true;
	public static final boolean component___CopterControlComponent___componentRefShm___Default_IdleTask_CPUUtilization___mode___r = true;
	public static final boolean component___CopterControlComponent___componentRefShm___Default_SignalProcessing_basicSensorData_t = true;
	public static final boolean component___CopterControlComponent___componentRefShm___Default_SignalProcessing_basicSensorData_t___mode___r = true;
	public static final boolean component___CopterControlComponent___componentRefShm___Default_SignalProcessing_sensorData_t = true;
	public static final boolean component___CopterControlComponent___componentRefShm___Default_SignalProcessing_sensorData_t___mode___r = true;
	public static final boolean component___CopterControlComponent___componentRefShm___FlightControl_flightControlApplicationModes_t = true;
	public static final boolean component___CopterControlComponent___componentRefShm___FlightControl_flightControlApplicationModes_t___mode___r = true;
	public static final boolean component___CopterControlComponent___componentRefShm___SignalProcessing_flightControlApplicationModes_t = true;
	public static final boolean component___CopterControlComponent___componentRefShm___SignalProcessing_flightControlApplicationModes_t___mode___r = true;
	public static final boolean component___EthernetComponent___componentRefApp___EthernetApp = true;
	public static final boolean component___EthernetComponent___componentRefShm___Default_Ethernet_ethRemoteCtrlData_t = true;
	public static final boolean component___EthernetComponent___componentRefShm___Default_Ethernet_ethRemoteCtrlData_t___mode___rw = true;
	public static final boolean component___FlightControlComponent___componentRefApp___FlightControlApp = true;
	public static final boolean component___FlightControlComponent___componentRefShm___CopterControl_flightControlApplicationModes_t = true;
	public static final boolean component___FlightControlComponent___componentRefShm___CopterControl_flightControlApplicationModes_t___mode___r = true;
	public static final boolean component___FlightControlComponent___componentRefShm___Default_CopterControl_basicFlightCtrlData_t = true;
	public static final boolean component___FlightControlComponent___componentRefShm___Default_CopterControl_basicFlightCtrlData_t___mode___r = true;
	public static final boolean component___FlightControlComponent___componentRefShm___Default_FlightControl_angularObserverData_t = true;
	public static final boolean component___FlightControlComponent___componentRefShm___Default_FlightControl_angularObserverData_t___mode___rw = true;
	public static final boolean component___FlightControlComponent___componentRefShm___Default_SignalProcessing_basicSensorData_t = true;
	public static final boolean component___FlightControlComponent___componentRefShm___Default_SignalProcessing_basicSensorData_t___mode___r = true;
	public static final boolean component___FlightControlComponent___componentRefShm___FlightControl_flightControlApplicationModes_t = true;
	public static final boolean component___FlightControlComponent___componentRefShm___FlightControl_flightControlApplicationModes_t___mode___rw = true;
	public static final boolean component___InitTaskComponent___componentRefApp___InitTaskApp = true;
	public static final boolean component___InitTaskComponent___componentRefShm___Default_IdleTask_CPUUtilization = true;
	public static final boolean component___InitTaskComponent___componentRefShm___Default_IdleTask_CPUUtilization___mode___rw = true;
	public static final boolean component___SPIComComponent___componentRefApp___SPIComApp = true;
	public static final boolean component___SignalProcessingComponent___componentRefApp___SignalProcessingApp = true;
	public static final boolean component___SignalProcessingComponent___componentRefShm___CopterControl_flightControlApplicationModes_t = true;
	public static final boolean component___SignalProcessingComponent___componentRefShm___CopterControl_flightControlApplicationModes_t___mode___r = true;
	public static final boolean component___SignalProcessingComponent___componentRefShm___Default_CopterControl_steeringStatusData_t = true;
	public static final boolean component___SignalProcessingComponent___componentRefShm___Default_CopterControl_steeringStatusData_t___mode___r = true;
	public static final boolean component___SignalProcessingComponent___componentRefShm___Default_SignalProcessing_basicSensorData_t = true;
	public static final boolean component___SignalProcessingComponent___componentRefShm___Default_SignalProcessing_basicSensorData_t___mode___rw = true;
	public static final boolean component___SignalProcessingComponent___componentRefShm___Default_SignalProcessing_sensorData_t = true;
	public static final boolean component___SignalProcessingComponent___componentRefShm___Default_SignalProcessing_sensorData_t___mode___rw = true;
	public static final boolean component___SignalProcessingComponent___componentRefShm___SignalProcessing_flightControlApplicationModes_t = true;
	public static final boolean component___SignalProcessingComponent___componentRefShm___SignalProcessing_flightControlApplicationModes_t___mode___rw = true;
	public static final boolean startupHook___run_app_hw_init = true;
	public static final int counter___sysCounter___maxallowedvalue = 255;
	public static final int counter___sysCounter___ticksperbase = 225000;
	public static final int counter___sysCounter___mincycle = 1;
	public static final int msgPort___ADXL345SPICom___msgcount = 2;
	public static final boolean msgPort___ADXL345SPICom___senderportref___SignalProcessingComponent = true;
	public static final boolean msgPort___ADXL345SPICom___receiverportref___SPIComComponent = true;
	public static final int msgPort___SPIComADXL345___msgcount = 2;
	public static final boolean msgPort___SPIComADXL345___senderportref___SPIComComponent = true;
	public static final boolean msgPort___SPIComADXL345___receiverportref___SignalProcessingComponent = true;
	public static final int msgPort___BLCtrlMasterSPICom___msgcount = 2;
	public static final boolean msgPort___BLCtrlMasterSPICom___senderportref___FlightControlComponent = true;
	public static final boolean msgPort___BLCtrlMasterSPICom___receiverportref___SPIComComponent = true;
	public static final int msgPort___SPIComBLCtrlMaster___msgcount = 2;
	public static final boolean msgPort___SPIComBLCtrlMaster___senderportref___SPIComComponent = true;
	public static final boolean msgPort___SPIComBLCtrlMaster___receiverportref___FlightControlComponent = true;
	public static final int msgPort___CopterControlTelemetryEthernet___msgcount = 2;
	public static final boolean msgPort___CopterControlTelemetryEthernet___senderportref___CopterControlComponent = true;
	public static final boolean msgPort___CopterControlTelemetryEthernet___receiverportref___EthernetComponent = true;
	public static final int msgPort___EnginePowerSwitchSPICom___msgcount = 2;
	public static final boolean msgPort___EnginePowerSwitchSPICom___senderportref___CopterControlComponent = true;
	public static final boolean msgPort___EnginePowerSwitchSPICom___receiverportref___SPIComComponent = true;
	public static final int msgPort___SPIComEnginePowerSwitch___msgcount = 2;
	public static final boolean msgPort___SPIComEnginePowerSwitch___senderportref___SPIComComponent = true;
	public static final boolean msgPort___SPIComEnginePowerSwitch___receiverportref___CopterControlComponent = true;
	public static final int msgPort___FlightControlTelemetryEthernet___msgcount = 2;
	public static final boolean msgPort___FlightControlTelemetryEthernet___senderportref___FlightControlComponent = true;
	public static final boolean msgPort___FlightControlTelemetryEthernet___receiverportref___EthernetComponent = true;
	public static final int msgPort___MK3MagSPICom___msgcount = 2;
	public static final boolean msgPort___MK3MagSPICom___senderportref___SignalProcessingComponent = true;
	public static final boolean msgPort___MK3MagSPICom___receiverportref___SPIComComponent = true;
	public static final int msgPort___SPIComMK3Mag___msgcount = 2;
	public static final boolean msgPort___SPIComMK3Mag___senderportref___SPIComComponent = true;
	public static final boolean msgPort___SPIComMK3Mag___receiverportref___SignalProcessingComponent = true;
	public static final int msgPort___SignalProcessingTelemetryEthernet___msgcount = 2;
	public static final boolean msgPort___SignalProcessingTelemetryEthernet___senderportref___SignalProcessingComponent = true;
	public static final boolean msgPort___SignalProcessingTelemetryEthernet___receiverportref___EthernetComponent = true;
	public static final int msgPort___TLV5618SPICom___msgcount = 2;
	public static final boolean msgPort___TLV5618SPICom___senderportref___SignalProcessingComponent = true;
	public static final boolean msgPort___TLV5618SPICom___receiverportref___SPIComComponent = true;
	public static final int msgPort___SPIComTLV5618___msgcount = 2;
	public static final boolean msgPort___SPIComTLV5618___senderportref___SPIComComponent = true;
	public static final boolean msgPort___SPIComTLV5618___receiverportref___SignalProcessingComponent = true;
	public static final int msgPort___SCP1000SPICom___msgcount = 2;
	public static final boolean msgPort___SCP1000SPICom___senderportref___SignalProcessingComponent = true;
	public static final boolean msgPort___SCP1000SPICom___receiverportref___SPIComComponent = true;
	public static final int msgPort___SPIComSCP1000___msgcount = 2;
	public static final boolean msgPort___SPIComSCP1000___senderportref___SPIComComponent = true;
	public static final boolean msgPort___SPIComSCP1000___receiverportref___SignalProcessingComponent = true;
	public static final boolean appmode___myAppMode___autostart___EthernetTask = true;
	public static final boolean appmode___myAppMode___autostart___SPIComTask = true;
	public static final boolean alarm___wakeCopterControl___basedOnCounter___sysCounter = true;
	public static final boolean alarm___wakeCopterControl___armed = true;
	public static final int alarm___wakeCopterControl___absolutelifetime = 50;
	public static final int alarm___wakeCopterControl___cycletime = 7;
	public static final boolean alarm___wakeCopterControl___activatetask = true;
	public static final boolean alarm___wakeCopterControl___activatetask___task___CopterControlTask = true;
	public static final boolean alarm___wakeCopterControlTelemetry___basedOnCounter___sysCounter = true;
	public static final boolean alarm___wakeCopterControlTelemetry___armed = true;
	public static final int alarm___wakeCopterControlTelemetry___absolutelifetime = 50;
	public static final int alarm___wakeCopterControlTelemetry___cycletime = 9;
	public static final boolean alarm___wakeCopterControlTelemetry___activatetask = true;
	public static final boolean alarm___wakeCopterControlTelemetry___activatetask___task___CopterControlTelemetryTask = true;
	public static final boolean alarm___wakeFlightControl___basedOnCounter___sysCounter = true;
	public static final boolean alarm___wakeFlightControl___armed = true;
	public static final int alarm___wakeFlightControl___absolutelifetime = 50;
	public static final int alarm___wakeFlightControl___cycletime = 3;
	public static final boolean alarm___wakeFlightControl___activatetask = true;
	public static final boolean alarm___wakeFlightControl___activatetask___task___FlightControlTask = true;
	public static final boolean alarm___wakeSignalProcessing___basedOnCounter___sysCounter = true;
	public static final boolean alarm___wakeSignalProcessing___armed = true;
	public static final int alarm___wakeSignalProcessing___absolutelifetime = 50;
	public static final int alarm___wakeSignalProcessing___cycletime = 1;
	public static final boolean alarm___wakeSignalProcessing___activatetask = true;
	public static final boolean alarm___wakeSignalProcessing___activatetask___task___SignalProcessingTask = true;
	public static final boolean alarm___restartDMA___basedOnCounter___sysCounter = true;
	public static final int alarm___restartDMA___absolutelifetime = 0;
	public static final int alarm___restartDMA___cycletime = 4;
	public static final boolean alarm___restartDMA___activatetask = true;
	public static final boolean alarm___restartDMA___activatetask___task___restartDMATask = true;
	public static final boolean hasApplicationHeader = true;
	public static final boolean i4copter_software = true;
	public static final int cfnetwork_config_ip = 0x2222a8c0;
	public static final int cfnetwork_config_ip_basestation = 0x822a8c0;
	public static final boolean cfcopter_coptercontrol_java = true;
	public static final boolean cfcopter_ethernet_java = true;
	public static final boolean cfcopter_flightcontrol_java = true;
	public static final boolean cfcopter_signalprocessing_java = true;
	public static final boolean cfcopter_spicom_java = true;

}
