/**(c)

  Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt

  This file is part of the KESO Java Runtime Environment.

  KESO is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

  KESO is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package trafficlight;

import keso.core.*;

/**
 * Implementation of the TrafficLightService.
 */
public class TrafficLightService implements TrafficLightServiceInterface, Service {
	/**
	 * Triggers a signal switch.
	 *
	 * This code is executed in the context of the service domain. Running the code
	 * in a different domain would not work: The Name Service would return a null
	 * reference (service protection).
	 */
	public boolean signalSwitch() {
		// call the actual signalSwitch method of the tlTask object
		// retrieve the object via the name service
		return TrafficLightTask.signalSwitch();
	}
}
