# /**(c)
# 
#   Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt
# 
#   This file is part of the KESO Java Runtime Environment.
# 
#   KESO is free software: you can redistribute it and/or modify it under the
#   terms of the Lesser GNU General Public License as published by the Free
#   Software Foundation, either version 3 of the License, or (at your option)
#   any later version.
# 
#   KESO is distributed in the hope that it will be useful, but WITHOUT ANY
#   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#   FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
#   more details. You should have received a copy of the GNU Lesser General
#   Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.
# 
#   Please contact keso@cs.fau.de for more info.
# 
#   (c)**/

$dumpInvokeOperands = "String result = \"\";\n"
                    . "\t\tif (obj != null)\n"
                    . "\t\t\tresult += obj.getRegId() + \".\";\n"
                    . "\t\tresult += cpEntry.getDescription();\n"
                    . "\t\tif (args.length > 0)\n"
                    . "\t\t\tresult += ' ';"
                    . "\t\tfor (int i = 0; i < args.length; ++i) {\n"
                    . "\t\t\tif (i > 0)\n"
                    . "\t\t\t\tresult += \", \";\n"
                    . "\t\t\tresult += args[i].getRegId();\n"
                    . "\t\t}\n"
                    . "\t\treturn result;";

%dumpbc=(
    'IMAConstant'          => 'return value.toString();',
    'IMAMemConstant'       => 'return alias + ", " + size;',
    'IMAMTConstant'        => 'return alias;',
    'IMArrayLength'        => 'return getRegId(array);',
    'IMCastD2F'            => 'return getRegId(rOpr);',
    'IMCastD2I'            => 'return getRegId(rOpr);',
    'IMCastD2L'            => 'return getRegId(rOpr);',
    'IMCastF2D'            => 'return getRegId(rOpr);',
    'IMCastF2I'            => 'return getRegId(rOpr);',
    'IMCastF2L'            => 'return getRegId(rOpr);',
    'IMCastI2B'            => 'return getRegId(rOpr);',
    'IMCastI2C'            => 'return getRegId(rOpr);',
    'IMCastI2D'            => 'return getRegId(rOpr);',
    'IMCastI2F'            => 'return getRegId(rOpr);',
    'IMCastI2L'            => 'return getRegId(rOpr);',
    'IMCastI2S'            => 'return getRegId(rOpr);',
    'IMCastL2D'            => 'return getRegId(rOpr);',
    'IMCastL2F'            => 'return getRegId(rOpr);',
    'IMCastL2I'            => 'return getRegId(rOpr);',
    'IMCheckCast'          => 'return cpEntry.getClassName();',
    'IMDConstant'          => 'return "" + value;',
    'IMEpilog'             => 'return getVarName(var);',
    'IMFConstant'          => 'return "" + value;',
    'IMGetField'           => 'return getRegId(rOpr) + "." + '
                            . 'cpEntry.getMemberName();',
    'IMGetStatic'          => 'return toReadableString();',
    'IMGoto'               => 'return getTargetsString();',
    'IMIConstant'          => 'return "" + value;',
    'IMInstanceOf'         => 'return cpEntry.getClassName();',
    'IMInvokeInterface'    => $dumpInvokeOperands,
    'IMInvokeSpecial'      => $dumpInvokeOperands,
    'IMInvokeStatic'       => $dumpInvokeOperands,
    'IMInvokeVirtual'      => $dumpInvokeOperands,
    'IMLConstant'          => 'return "" + value;',
    'IMNew'                => "String operands = cpEntry.getClassName();\n"
                            . "\t\tif (escapeState == EscapeState.Local)\n"
                            . "\t\t\toperands += \" # local\";\n"
                            . "\t\tif (livenessOverlap)\n"
                            . "\t\t\toperands += \" # liveness regions overlap\";\n"
                            . "\t\treturn operands;",
    'IMNewArray'           => "String operands = aclass.getClassName() + \", \" + getRegId(size);\n"
                            . "\t\tif (escapeState == EscapeState.Local)\n"
                            . "\t\t\toperands += \" # local\";\n"
                            . "\t\tif (livenessOverlap)\n"
                            . "\t\t\toperands += \" # liveness regions overlap\";\n"
                            . "\t\treturn operands;",
    'IMNewMultiArray'      => "String operands = cpEntry.getClassName() + \", \" + dim + \", \";\n"
                            . "\t\tfor (int i = 0; i < oprs.length; ++i) {\n"
                            . "\t\t\tif (i > 0)\n"
                            . "\t\t\t\toperands += \", \";\n"
                            . "\t\t\toperands += getRegId(oprs[i]);\n"
                            . "\t\t}\n"
                            . "\t\tif (escapeState == EscapeState.Local)\n"
                            . "\t\t\toperands += \" # local\";\n"
                            . "\t\tif (livenessOverlap)\n"
                            . "\t\t\toperands += \" # liveness regions overlap\";\n"
                            . "\t\treturn operands;",
    'IMNewObjArray'         => "String operands = cpEntry.getClassName() + \", \" + getRegId(size);\n"
                            . "\t\tif (escapeState == EscapeState.Local)\n"
                            . "\t\t\toperands += \" # local\";\n"
                            . "\t\tif (livenessOverlap)\n"
                            . "\t\t\toperands += \" # liveness regions overlap\";\n"
                            . "\t\treturn operands;",
    'IMPhi' => "String result = \"\";\n"
             . "\t\tIMBasicBlockList pred = bb.getPred();\n"
             . "\t\tfor (int i = 0; i < slots.length; ++i) {\n"
             . "\t\t\tif (i > 0)\n"
             . "\t\t\t\tresult += \", \";\n"
             . "\t\t\tresult += getRegId(slots[i]) + \" [\" + "
                . "pred.at(i).getShortLabel() + \"]\";\n"
             . "\t\t}\n"
             . "\t\treturn result;",
    'IMPutField'           => 'return getRegId(obj) + "." + '
                            . 'cpEntry.getMemberName() + ", " + '
                            . 'getRegId(rvalue);',
    'IMPutStatic'          => 'return cpEntry.getMemberName() + ", " + '
                            . 'getRegId(rvalue);',
    'IMReadArray'          => 'return getRegId(aOpr) + ", " + getRegId(iOpr);',
    'IMReadLocalVariable'  => 'return getVarName(var);',
    'IMStoreArray'         => 'return getRegId(aOpr) + ", " + '
                            . 'getRegId(iOpr) + ", " + getRegId(rvalue);',
    'IMStoreLocalVariable' => 'return getVarName(var) + ", " + '
                            . 'getRegId(operand);',
    'IMTableSwitch'        => 'return getRegId(operand) + ", " + low + ", " + '
                            . 'high + ", " + getTargetsString();',
    'IMThrow'              => 'return getRegId(exception);'
);
