# /**(c)
# 
#   Copyright (C) 2006-2012 Christian Wawersich, Michael Stilkerich, Christoph Erhardt
# 
#   This file is part of the KESO Java Runtime Environment.
# 
#   KESO is free software: you can redistribute it and/or modify it under the
#   terms of the Lesser GNU General Public License as published by the Free
#   Software Foundation, either version 3 of the License, or (at your option)
#   any later version.
# 
#   KESO is distributed in the hope that it will be useful, but WITHOUT ANY
#   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#   FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
#   more details. You should have received a copy of the GNU Lesser General
#   Public License along with KESO. If not, see <http://www.gnu.org/licenses/>.
# 
#   Please contact keso@cs.fau.de for more info.
# 
#   (c)**/

my $evaluateCastD2X = "\t\t\%JTYPE\% value = (\%JTYPE\%) args[0].getDoubleValue();
\t\treturn method.createIM\%NSTYPE\%Constant(value, bcPosition);";

my $evaluateCastF2X = "\t\t\%JTYPE\% value = (\%JTYPE\%) args[0].getFloatValue();
\t\treturn method.createIM\%NSTYPE\%Constant(value, bcPosition);";

my $evaluateCastI2X = "\t\t\%JTYPE\% value = (\%JTYPE\%) args[0].getIntValue();
\t\treturn method.createIM\%NSTYPE\%Constant(value, bcPosition);";

my $evaluateCastL2X = "\t\t\%JTYPE\% value = (\%JTYPE\%) args[0].getLongValue();
\t\treturn method.createIM\%NSTYPE\%Constant(value, bcPosition);";

my $evaluateCheck = "\t\tif (args[0] == null || args[1] == null)
\t\t\treturn null;";

my $doEvaluateBinOp = "\t\treturn method.createIM\%STYPE\%Constant(args[0].get\%UJTYPE\%Value()
\t\t\t\t\%BIN_OP\%  args[1].get\%UJTYPE\%Value(), bcPosition);";

my $evaluateConditional = "$evaluateCheck
\t\treturn getTargetFor(args[0].compareTo(args[1]) \%BIN_OP\% 0);";

my $evaluateBinOp = "$evaluateCheck
$doEvaluateBinOp";

my $evaluateBinOpDiv = "$evaluateCheck
\t\tif (args[1].get\%UJTYPE\%Value() == 0) {
\t\t\topts.warn(\"division by zero in \" + method.getAlias());
\t\t\treturn null;
\t\t}
$doEvaluateBinOp";

my $evaluateNeg = "\t\treturn method.createIM\%STYPE\%Constant(-args[0].get\%UJTYPE\%Value(), bcPosition);";

# FIXME: Some cast operators are disabled due to unclear semantics
%evaluate = (
    #'IMCastD2F'             => $evaluateCastD2X,
    'IMCastD2I'             => $evaluateCastD2X,
    'IMCastD2L'             => $evaluateCastD2X,
    #'IMCastF2D'             => $evaluateCastF2X,
    'IMCastF2I'             => $evaluateCastF2X,
    'IMCastF2L'             => $evaluateCastF2X,
    #'IMCastI2B'             => $evaluateCastI2X,
    #'IMCastI2C'             => $evaluateCastI2X,
    #'IMCastI2D'             => $evaluateCastI2X,
    #'IMCastI2F'             => $evaluateCastI2X,
    'IMCastI2L'             => $evaluateCastI2X,
    #'IMCastI2S'             => $evaluateCastI2X,
    #'IMCastL2D'             => $evaluateCastL2X,
    #'IMCastL2F'             => $evaluateCastL2X,
    'IMCastL2I'             => $evaluateCastL2X,
    'IMEQConditionalBranch' => $evaluateConditional,
    'IMGEConditionalBranch' => $evaluateConditional,
    'IMGTConditionalBranch' => $evaluateConditional,
    'IMLEConditionalBranch' => $evaluateConditional,
    'IMLTConditionalBranch' => $evaluateConditional,
    'IMNEConditionalBranch' => $evaluateConditional,
    'IMDAdd'                => $evaluateBinOp,
    'IMDDiv'                => $evaluateBinOpDiv,
    'IMDMul'                => $evaluateBinOp,
    'IMDNeg'                => $evaluateNeg,
    'IMDRem'                => $evaluateBinOpDiv,
    'IMDSub'                => $evaluateBinOp,
    'IMFAdd'                => $evaluateBinOp,
    'IMFDiv'                => $evaluateBinOpDiv,
    'IMFMul'                => $evaluateBinOp,
    'IMFNeg'                => $evaluateNeg,
    'IMFRem'                => $evaluateBinOpDiv,
    'IMFSub'                => $evaluateBinOp,
    'IMIAdd'                => $evaluateBinOp,
    'IMIBitAnd'             => $evaluateBinOp,
    'IMIBitOr'              => $evaluateBinOp,
    'IMIBitXor'             => $evaluateBinOp,
    'IMIDiv'                => $evaluateBinOpDiv,
    'IMIMul'                => $evaluateBinOp,
    'IMINeg'                => $evaluateNeg,
    'IMIRem'                => $evaluateBinOpDiv,
    'IMIShiftLeft'          => $evaluateBinOp,
    'IMIShiftRight'         => $evaluateBinOp,
    'IMIShiftRight2'        => $evaluateBinOp,
    'IMISub'                => $evaluateBinOp,
    'IMLAdd'                => $evaluateBinOp,
    'IMLBitAnd'             => $evaluateBinOp,
    'IMLBitOr'              => $evaluateBinOp,
    'IMLBitXor'             => $evaluateBinOp,
    'IMLDiv'                => $evaluateBinOpDiv,
    'IMLMul'                => $evaluateBinOp,
    'IMLNeg'                => $evaluateNeg,
    'IMLRem'                => $evaluateBinOpDiv,
    'IMLShiftLeft'          => $evaluateBinOp,
    'IMLShiftRight'         => $evaluateBinOp,
    'IMLShiftRight2'        => $evaluateBinOp,
    'IMLSub'                => $evaluateBinOp,
);

%evaluateMin = (
    'IMIAdd' => "\t\treturn limits[0] + limits[2];",
    'IMISub' => "\t\treturn limits[0] - limits[3];",
);

%evaluateMax = (
    'IMIAdd' => "\t\treturn limits[1] + limits[3];",
    'IMISub' => "\t\treturn limits[1] - limits[2];",
);
